/*
 * Copyright 2016 Broadcom
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation (the "GPL").
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License version 2 (GPLv2) for more details.
 *
 * You should have received a copy of the GNU General Public License
 * version 2 (GPLv2) along with this source code.
 */

#ifndef BCM_IPROC_SMC_H
#define BCM_IPROC_SMC_H

/* Broadcom Secure Service API Return Codes */
#define SEC_ROM_RET_OK                          0x00000001
#define SEC_ROM_RET_FAIL                        0x0E000001

#define SSAPI_RET_FROM_INT_SERV                 0x4
#define SEC_EXIT_NORMAL                         0x1

#define SSAPI_AUTHENTICATE_COMMAND              0x01003000

#define SEC_AUTH_BASE                           SSAPI_AUTHENTICATE_COMMAND
#define SSAPI_BRCM_HASH_CREATE                  SEC_AUTH_BASE + 0
#define SSAPI_BRCM_RSA_PUBLIC_DECRYPT           SEC_AUTH_BASE + 1

struct ssapi_hash_create_data {
	uint32_t input_size;
	uint32_t hashAlgo;
	uint32_t useDma;
	uint32_t output_size;

	uint32_t input_data_phy;
	uint8_t  output_data_phy[32];
	uint32_t cmd;
};

struct ssapi_public_decrypt_data {
	uint32_t encryptedDataSize;
	uint32_t modLen;
	uint32_t exp;
	uint32_t decryptedDataSize;

	uint32_t encryptedData_phy;
	uint32_t keyLocation_phy;
	uint32_t decryptedData_phy;
	uint32_t cmd;
};

#endif /* BCM_IPROC_SMC_H */
