/*
 * Copyright 2015 Broadcom Corporation.
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

#ifndef __CONFIGS_DIAGS_H
#define __CONFIGS_DIAGS_H

/* Diagnostics */
#define CONFIG_IPROC_BOARD_DIAGS
#define CONFIG_CYGNUS_BOARD_DIAGS

#if defined(CONFIG_IPROC_BOARD_DIAGS) && !defined(CONFIG_NO_CODE_RELOC)
#define IPROC_BOARD_DIAGS
#endif /* CONFIG_IPROC_BOARD_DIAGS */

#if defined(CONFIG_CYGNUS_BOARD_DIAGS)
#define CYGNUS_BOARD_DIAGS
#endif /* CONFIG_CYGNUS_BOARD_DIAGS */

#ifdef IPROC_BOARD_DIAGS

#define CONFIG_HAS_POST
/*define post to support diags available, this is a ORed list See bitmask
 * definition in post.h */
#ifdef CYGNUS_BOARD_DIAGS
#define CONFIG_POST (\
	CONFIG_SYS_POST_QSPI | \
	CONFIG_SYS_POST_PWM | \
	CONFIG_SYS_POST_GPIO | \
	CONFIG_SYS_POST_I2C | \
	CONFIG_SYS_POST_EMMC | \
	CONFIG_SYS_POST_MMC | \
	CONFIG_SYS_POST_NAND | \
	CONFIG_SYS_POST_KEYPAD | \
	CONFIG_SYS_POST_TDM | \
	CONFIG_SYS_POST_AUDIO | \
	CONFIG_SYS_POST_USB20 | \
	CONFIG_SYS_POST_TOUCHSCREEN | \
	CONFIG_SYS_POST_LCD | \
	CONFIG_SYS_POST_SPI | \
	CONFIG_SYS_POST_UART | \
	CONFIG_SYS_POST_PCIE | \
	CONFIG_SYS_POST_SPDIF | \
	CONFIG_SYS_POST_MEMORY | \
	CONFIG_SYS_POST_AMACSWITCH)

/* USB */
#define CONFIG_CMD_USB
/*#define CONFIG_USB_EHCI*/
#define CONFIG_USB_EHCI_IPROC
#define CONFIG_USB_STORAGE
#define CONFIG_CMD_FAT
#define CONFIG_DOS_PARTITION
#define CONFIG_LEGACY_USB_INIT_SEQ

#else /* CYGNUS_BOARD_DIAGS */
#define CONFIG_POST (\
	CONFIG_SYS_POST_UART | \
	CONFIG_SYS_POST_QSPI | \
	CONFIG_SYS_POST_NAND | \
	CONFIG_SYS_POST_RGMII | \
	CONFIG_SYS_POST_MEMORY)
#endif /* CYGNUS_BOARD_DIAGS */

#define CONFIG_CMD_DIAG

/* UART */
#define CONFIG_UART0_INDEX	0
#define CONFIG_UART1_INDEX	1
#define CONFIG_UART2_INDEX	2
#define CONFIG_UART3_INDEX	3
#define CONFIG_UART4_INDEX	4

/* Memory */
#define CONFIG_DIAGS_MEMTEST_START			0x61000000
#define CONFIG_DIAGS_MEMTEST_END			0xA0000000
#define CONFIG_DIAGS_INTERNAL_SRAMTEST_SIZE	(256*1024)

/* PWM */
#define CONFIG_IPROC_PWM
#define CONFIG_HAS_PWM

/* GPIO */
#define CONFIG_IPROC_GPIO

/* PCIE */
#define CONFIG_CMD_PCI
#define CONFIG_CMD_PCI_ENUM
#define CONFIG_PCI
#define CONFIG_PCI_SCAN_SHOW
#define CONFIG_IPROC_PCIE

/* I2C */
#define CONFIG_CMD_I2C
#define CONFIG_IPROC_I2C
#define CONFIG_SYS_I2C_SLAVE	0xff /* No slave address */
#define CONFIG_I2C_MULTI_BUS

/* NAND */
#define CONFIG_CMD_NAND

/* MMC */
#define CONFIG_CMD_MMC
#define CONFIG_GENERIC_MMC

/* USB */
#define CONFIG_USB_GADGET
#define CONFIG_USB_GADGET_DUALSPEED
#define CONFIG_USB_GADGET_VBUS_DRAW	0
#define CONFIG_USBDOWNLOAD_GADGET
#define CONFIG_G_DNL_VENDOR_NUM		0x18D1/*google*/
#define CONFIG_G_DNL_PRODUCT_NUM	0x0D02/*nexus one*/
#define CONFIG_G_DNL_MANUFACTURER	"Broadcom"

/* Fastboot */
#define CONFIG_CMD_FASTBOOT
#define CONFIG_FASTBOOT_FLASH
#define CONFIG_ANDROID_BOOT_IMAGE
#define CONFIG_USB_FASTBOOT_BUF_ADDR	CONFIG_SYS_LOAD_ADDR
#define CONFIG_USB_FASTBOOT_BUF_SIZE	0x12C00000
#define CONFIG_SYS_CACHELINE_SIZE	32
#define CONFIG_DFU_FUNCTION

/* Watchdog */
#define CONFIG_HW_WATCHDOG
#define CONFIG_ARM_SP805_WDT
#define CONFIG_ARM_SP805_WDT_BASE	0x18009000 /* Chip-Common WDT */
#define CONFIG_ARM_SP805_WDT_FREQ	100000000  /* Hz */

#endif /* IPROC_BOARD_DIAGS */

#endif /* __CONFIGS_DIAGS_H */
