/*
 * Copyright 2016 Broadcom
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation (the "GPL").
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License version 2 (GPLv2) for more details.
 *
 * You should have received a copy of the GNU General Public License
 * version 2 (GPLv2) along with this source code.
 */

/*
 * ===========================================================================
 * Secure API function define
 *
 */

#ifndef _SECURE_API_H_
#define _SECURE_API_H_

#define SEC_FLAG 0x0F


/* Trap to secure world by us */
u32 secure_api_call(u32 service_id, u32 arg0, u32 arg1,
	u32 arg2, u32 arg3, u32 arg4, u32 arg5,
	u32 arg6, u32 arg7, u32 arg8);

/* Compute binary hash */
unsigned int ssapi_hash_create(unsigned char *outbuffer,
	unsigned int outsize,
	unsigned char *inbuffer,
	unsigned int insize,
	unsigned int hashalgo,
	unsigned int usehw);

/* Decrypt signature */
unsigned int ssapi_rsa_public_decrypt(unsigned char *decrypteddata,
	unsigned int *decrypteddatasize,
	unsigned char *encrypteddata,
	unsigned int encryteddatasize,
	unsigned int keylocation,
	unsigned int modlen,
	unsigned int exp);

#endif
