/************************************************************************************************/
/*                                                                                              */
/*  Copyright 2011  Broadcom Corporation                                                        */
/*                                                                                              */
/*     Unless you and Broadcom execute a separate written software license agreement governing  */
/*     use of this software, this software is licensed to you under the terms of the GNU        */
/*     General Public License version 2 (the GPL), available at                                 */
/*                                                                                              */
/*          http://www.broadcom.com/licenses/GPLv2.php                                          */
/*                                                                                              */
/*     with the following added to such license:                                                */
/*                                                                                              */
/*     As a special exception, the copyright holders of this software give you permission to    */
/*     link this software with independent modules, and to copy and distribute the resulting    */
/*     executable under terms of your choice, provided that you also meet, for each linked      */
/*     independent module, the terms and conditions of the license of that module.              */
/*     An independent module is a module which is not derived from this software.  The special  */
/*     exception does not apply to any modifications of the software.                           */
/*                                                                                              */
/*     Notwithstanding the above, under no circumstances may you combine this software in any   */
/*     way with any other Broadcom software provided under a license other than the GPL,        */
/*     without Broadcom's express prior written consent.                                        */
/*                                                                                              */
/*     Date     : Generated on 11/1/2011 14:30:46                                             */
/*     RDB file : /projects/CHIP/revA0                                                                   */
/************************************************************************************************/

#ifndef __BRCM_RDB_KPM_CLK_MGR_REG_H__
#define __BRCM_RDB_KPM_CLK_MGR_REG_H__

#define KPM_CLK_MGR_REG_WR_ACCESS_OFFSET                                  0x00000000
#define KPM_CLK_MGR_REG_WR_ACCESS_TYPE                                    UInt32
#define KPM_CLK_MGR_REG_WR_ACCESS_RESERVED_MASK                           0x7F0000FE
#define    KPM_CLK_MGR_REG_WR_ACCESS_PRIV_ACCESS_MODE_SHIFT               31
#define    KPM_CLK_MGR_REG_WR_ACCESS_PRIV_ACCESS_MODE_MASK                0x80000000
#define    KPM_CLK_MGR_REG_WR_ACCESS_PASSWORD_SHIFT                       8
#define    KPM_CLK_MGR_REG_WR_ACCESS_PASSWORD_MASK                        0x00FFFF00
#define    KPM_CLK_MGR_REG_WR_ACCESS_CLKMGR_ACC_SHIFT                     0
#define    KPM_CLK_MGR_REG_WR_ACCESS_CLKMGR_ACC_MASK                      0x00000001

#define KPM_CLK_MGR_REG_CCU_VERSION_OFFSET                                0x00000004
#define KPM_CLK_MGR_REG_CCU_VERSION_TYPE                                  UInt32
#define KPM_CLK_MGR_REG_CCU_VERSION_RESERVED_MASK                         0x7FFF0000
#define    KPM_CLK_MGR_REG_CCU_VERSION_PRIV_ACCESS_MODE_SHIFT             31
#define    KPM_CLK_MGR_REG_CCU_VERSION_PRIV_ACCESS_MODE_MASK              0x80000000
#define    KPM_CLK_MGR_REG_CCU_VERSION_PUBLISH_ID_SHIFT                   0
#define    KPM_CLK_MGR_REG_CCU_VERSION_PUBLISH_ID_MASK                    0x0000FFFF

#define KPM_CLK_MGR_REG_POLICY_FREQ_OFFSET                                0x00000008
#define KPM_CLK_MGR_REG_POLICY_FREQ_TYPE                                  UInt32
#define KPM_CLK_MGR_REG_POLICY_FREQ_RESERVED_MASK                         0x78F8F8F8
#define    KPM_CLK_MGR_REG_POLICY_FREQ_PRIV_ACCESS_MODE_SHIFT             31
#define    KPM_CLK_MGR_REG_POLICY_FREQ_PRIV_ACCESS_MODE_MASK              0x80000000
#define    KPM_CLK_MGR_REG_POLICY_FREQ_POLICY3_FREQ_SHIFT                 24
#define    KPM_CLK_MGR_REG_POLICY_FREQ_POLICY3_FREQ_MASK                  0x07000000
#define    KPM_CLK_MGR_REG_POLICY_FREQ_POLICY2_FREQ_SHIFT                 16
#define    KPM_CLK_MGR_REG_POLICY_FREQ_POLICY2_FREQ_MASK                  0x00070000
#define    KPM_CLK_MGR_REG_POLICY_FREQ_POLICY1_FREQ_SHIFT                 8
#define    KPM_CLK_MGR_REG_POLICY_FREQ_POLICY1_FREQ_MASK                  0x00000700
#define    KPM_CLK_MGR_REG_POLICY_FREQ_POLICY0_FREQ_SHIFT                 0
#define    KPM_CLK_MGR_REG_POLICY_FREQ_POLICY0_FREQ_MASK                  0x00000007

#define KPM_CLK_MGR_REG_POLICY_CTL_OFFSET                                 0x0000000C
#define KPM_CLK_MGR_REG_POLICY_CTL_TYPE                                   UInt32
#define KPM_CLK_MGR_REG_POLICY_CTL_RESERVED_MASK                          0x7FFFFFF0
#define    KPM_CLK_MGR_REG_POLICY_CTL_PRIV_ACCESS_MODE_SHIFT              31
#define    KPM_CLK_MGR_REG_POLICY_CTL_PRIV_ACCESS_MODE_MASK               0x80000000
#define    KPM_CLK_MGR_REG_POLICY_CTL_TGT_VLD_SHIFT                       3
#define    KPM_CLK_MGR_REG_POLICY_CTL_TGT_VLD_MASK                        0x00000008
#define    KPM_CLK_MGR_REG_POLICY_CTL_GO_ATL_SHIFT                        2
#define    KPM_CLK_MGR_REG_POLICY_CTL_GO_ATL_MASK                         0x00000004
#define    KPM_CLK_MGR_REG_POLICY_CTL_GO_AC_SHIFT                         1
#define    KPM_CLK_MGR_REG_POLICY_CTL_GO_AC_MASK                          0x00000002
#define    KPM_CLK_MGR_REG_POLICY_CTL_GO_SHIFT                            0
#define    KPM_CLK_MGR_REG_POLICY_CTL_GO_MASK                             0x00000001

#define KPM_CLK_MGR_REG_POLICY0_MASK_OFFSET                               0x00000010
#define KPM_CLK_MGR_REG_POLICY0_MASK_TYPE                                 UInt32
#define KPM_CLK_MGR_REG_POLICY0_MASK_RESERVED_MASK                        0x7FF8C500
#define    KPM_CLK_MGR_REG_POLICY0_MASK_PRIV_ACCESS_MODE_SHIFT            31
#define    KPM_CLK_MGR_REG_POLICY0_MASK_PRIV_ACCESS_MODE_MASK             0x80000000
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SPI_SLAVE_POLICY0_MASK_SHIFT      18
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SPI_SLAVE_POLICY0_MASK_MASK       0x00040000
#define    KPM_CLK_MGR_REG_POLICY0_MASK_USBH2_POLICY0_MASK_SHIFT          17
#define    KPM_CLK_MGR_REG_POLICY0_MASK_USBH2_POLICY0_MASK_MASK           0x00020000
#define    KPM_CLK_MGR_REG_POLICY0_MASK_HSIC2_POLICY0_MASK_SHIFT          16
#define    KPM_CLK_MGR_REG_POLICY0_MASK_HSIC2_POLICY0_MASK_MASK           0x00010000
#define    KPM_CLK_MGR_REG_POLICY0_MASK_APB8_POLICY0_MASK_SHIFT           13
#define    KPM_CLK_MGR_REG_POLICY0_MASK_APB8_POLICY0_MASK_MASK            0x00002000
#define    KPM_CLK_MGR_REG_POLICY0_MASK_ARMCORE_POLICY0_MASK_SHIFT        12
#define    KPM_CLK_MGR_REG_POLICY0_MASK_ARMCORE_POLICY0_MASK_MASK         0x00001000
#define    KPM_CLK_MGR_REG_POLICY0_MASK_USB_OTG_POLICY0_MASK_SHIFT        11
#define    KPM_CLK_MGR_REG_POLICY0_MASK_USB_OTG_POLICY0_MASK_MASK         0x00000800
#define    KPM_CLK_MGR_REG_POLICY0_MASK_USB_IC_POLICY0_MASK_SHIFT         9
#define    KPM_CLK_MGR_REG_POLICY0_MASK_USB_IC_POLICY0_MASK_MASK          0x00000200
#define    KPM_CLK_MGR_REG_POLICY0_MASK_NAND_POLICY0_MASK_SHIFT           7
#define    KPM_CLK_MGR_REG_POLICY0_MASK_NAND_POLICY0_MASK_MASK            0x00000080
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SDIO1_POLICY0_MASK_SHIFT          6
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SDIO1_POLICY0_MASK_MASK           0x00000040
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SDIO2_POLICY0_MASK_SHIFT          5
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SDIO2_POLICY0_MASK_MASK           0x00000020
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SDIO4_POLICY0_MASK_SHIFT          4
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SDIO4_POLICY0_MASK_MASK           0x00000010
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SDIO3_POLICY0_MASK_SHIFT          3
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SDIO3_POLICY0_MASK_MASK           0x00000008
#define    KPM_CLK_MGR_REG_POLICY0_MASK_MASTER_SWITCH_POLICY0_MASK_SHIFT  2
#define    KPM_CLK_MGR_REG_POLICY0_MASK_MASTER_SWITCH_POLICY0_MASK_MASK   0x00000004
#define    KPM_CLK_MGR_REG_POLICY0_MASK_DMA_POLICY0_MASK_SHIFT            1
#define    KPM_CLK_MGR_REG_POLICY0_MASK_DMA_POLICY0_MASK_MASK             0x00000002
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SYS_SWITCH_POLICY0_MASK_SHIFT     0
#define    KPM_CLK_MGR_REG_POLICY0_MASK_SYS_SWITCH_POLICY0_MASK_MASK      0x00000001

#define KPM_CLK_MGR_REG_POLICY1_MASK_OFFSET                               0x00000014
#define KPM_CLK_MGR_REG_POLICY1_MASK_TYPE                                 UInt32
#define KPM_CLK_MGR_REG_POLICY1_MASK_RESERVED_MASK                        0x7FF8C500
#define    KPM_CLK_MGR_REG_POLICY1_MASK_PRIV_ACCESS_MODE_SHIFT            31
#define    KPM_CLK_MGR_REG_POLICY1_MASK_PRIV_ACCESS_MODE_MASK             0x80000000
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SPI_SLAVE_POLICY1_MASK_SHIFT      18
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SPI_SLAVE_POLICY1_MASK_MASK       0x00040000
#define    KPM_CLK_MGR_REG_POLICY1_MASK_USBH2_POLICY1_MASK_SHIFT          17
#define    KPM_CLK_MGR_REG_POLICY1_MASK_USBH2_POLICY1_MASK_MASK           0x00020000
#define    KPM_CLK_MGR_REG_POLICY1_MASK_HSIC2_POLICY1_MASK_SHIFT          16
#define    KPM_CLK_MGR_REG_POLICY1_MASK_HSIC2_POLICY1_MASK_MASK           0x00010000
#define    KPM_CLK_MGR_REG_POLICY1_MASK_APB8_POLICY1_MASK_SHIFT           13
#define    KPM_CLK_MGR_REG_POLICY1_MASK_APB8_POLICY1_MASK_MASK            0x00002000
#define    KPM_CLK_MGR_REG_POLICY1_MASK_ARMCORE_POLICY1_MASK_SHIFT        12
#define    KPM_CLK_MGR_REG_POLICY1_MASK_ARMCORE_POLICY1_MASK_MASK         0x00001000
#define    KPM_CLK_MGR_REG_POLICY1_MASK_USB_OTG_POLICY1_MASK_SHIFT        11
#define    KPM_CLK_MGR_REG_POLICY1_MASK_USB_OTG_POLICY1_MASK_MASK         0x00000800
#define    KPM_CLK_MGR_REG_POLICY1_MASK_USB_IC_POLICY1_MASK_SHIFT         9
#define    KPM_CLK_MGR_REG_POLICY1_MASK_USB_IC_POLICY1_MASK_MASK          0x00000200
#define    KPM_CLK_MGR_REG_POLICY1_MASK_NAND_POLICY1_MASK_SHIFT           7
#define    KPM_CLK_MGR_REG_POLICY1_MASK_NAND_POLICY1_MASK_MASK            0x00000080
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SDIO1_POLICY1_MASK_SHIFT          6
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SDIO1_POLICY1_MASK_MASK           0x00000040
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SDIO2_POLICY1_MASK_SHIFT          5
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SDIO2_POLICY1_MASK_MASK           0x00000020
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SDIO4_POLICY1_MASK_SHIFT          4
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SDIO4_POLICY1_MASK_MASK           0x00000010
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SDIO3_POLICY1_MASK_SHIFT          3
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SDIO3_POLICY1_MASK_MASK           0x00000008
#define    KPM_CLK_MGR_REG_POLICY1_MASK_MASTER_SWITCH_POLICY1_MASK_SHIFT  2
#define    KPM_CLK_MGR_REG_POLICY1_MASK_MASTER_SWITCH_POLICY1_MASK_MASK   0x00000004
#define    KPM_CLK_MGR_REG_POLICY1_MASK_DMA_POLICY1_MASK_SHIFT            1
#define    KPM_CLK_MGR_REG_POLICY1_MASK_DMA_POLICY1_MASK_MASK             0x00000002
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SYS_SWITCH_POLICY1_MASK_SHIFT     0
#define    KPM_CLK_MGR_REG_POLICY1_MASK_SYS_SWITCH_POLICY1_MASK_MASK      0x00000001

#define KPM_CLK_MGR_REG_POLICY2_MASK_OFFSET                               0x00000018
#define KPM_CLK_MGR_REG_POLICY2_MASK_TYPE                                 UInt32
#define KPM_CLK_MGR_REG_POLICY2_MASK_RESERVED_MASK                        0x7FF8C500
#define    KPM_CLK_MGR_REG_POLICY2_MASK_PRIV_ACCESS_MODE_SHIFT            31
#define    KPM_CLK_MGR_REG_POLICY2_MASK_PRIV_ACCESS_MODE_MASK             0x80000000
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SPI_SLAVE_POLICY2_MASK_SHIFT      18
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SPI_SLAVE_POLICY2_MASK_MASK       0x00040000
#define    KPM_CLK_MGR_REG_POLICY2_MASK_USBH2_POLICY2_MASK_SHIFT          17
#define    KPM_CLK_MGR_REG_POLICY2_MASK_USBH2_POLICY2_MASK_MASK           0x00020000
#define    KPM_CLK_MGR_REG_POLICY2_MASK_HSIC2_POLICY2_MASK_SHIFT          16
#define    KPM_CLK_MGR_REG_POLICY2_MASK_HSIC2_POLICY2_MASK_MASK           0x00010000
#define    KPM_CLK_MGR_REG_POLICY2_MASK_APB8_POLICY2_MASK_SHIFT           13
#define    KPM_CLK_MGR_REG_POLICY2_MASK_APB8_POLICY2_MASK_MASK            0x00002000
#define    KPM_CLK_MGR_REG_POLICY2_MASK_ARMCORE_POLICY2_MASK_SHIFT        12
#define    KPM_CLK_MGR_REG_POLICY2_MASK_ARMCORE_POLICY2_MASK_MASK         0x00001000
#define    KPM_CLK_MGR_REG_POLICY2_MASK_USB_OTG_POLICY2_MASK_SHIFT        11
#define    KPM_CLK_MGR_REG_POLICY2_MASK_USB_OTG_POLICY2_MASK_MASK         0x00000800
#define    KPM_CLK_MGR_REG_POLICY2_MASK_USB_IC_POLICY2_MASK_SHIFT         9
#define    KPM_CLK_MGR_REG_POLICY2_MASK_USB_IC_POLICY2_MASK_MASK          0x00000200
#define    KPM_CLK_MGR_REG_POLICY2_MASK_NAND_POLICY2_MASK_SHIFT           7
#define    KPM_CLK_MGR_REG_POLICY2_MASK_NAND_POLICY2_MASK_MASK            0x00000080
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SDIO1_POLICY2_MASK_SHIFT          6
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SDIO1_POLICY2_MASK_MASK           0x00000040
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SDIO2_POLICY2_MASK_SHIFT          5
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SDIO2_POLICY2_MASK_MASK           0x00000020
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SDIO4_POLICY2_MASK_SHIFT          4
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SDIO4_POLICY2_MASK_MASK           0x00000010
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SDIO3_POLICY2_MASK_SHIFT          3
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SDIO3_POLICY2_MASK_MASK           0x00000008
#define    KPM_CLK_MGR_REG_POLICY2_MASK_MASTER_SWITCH_POLICY2_MASK_SHIFT  2
#define    KPM_CLK_MGR_REG_POLICY2_MASK_MASTER_SWITCH_POLICY2_MASK_MASK   0x00000004
#define    KPM_CLK_MGR_REG_POLICY2_MASK_DMA_POLICY2_MASK_SHIFT            1
#define    KPM_CLK_MGR_REG_POLICY2_MASK_DMA_POLICY2_MASK_MASK             0x00000002
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SYS_SWITCH_POLICY2_MASK_SHIFT     0
#define    KPM_CLK_MGR_REG_POLICY2_MASK_SYS_SWITCH_POLICY2_MASK_MASK      0x00000001

#define KPM_CLK_MGR_REG_POLICY3_MASK_OFFSET                               0x0000001C
#define KPM_CLK_MGR_REG_POLICY3_MASK_TYPE                                 UInt32
#define KPM_CLK_MGR_REG_POLICY3_MASK_RESERVED_MASK                        0x7FF8C500
#define    KPM_CLK_MGR_REG_POLICY3_MASK_PRIV_ACCESS_MODE_SHIFT            31
#define    KPM_CLK_MGR_REG_POLICY3_MASK_PRIV_ACCESS_MODE_MASK             0x80000000
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SPI_SLAVE_POLICY3_MASK_SHIFT      18
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SPI_SLAVE_POLICY3_MASK_MASK       0x00040000
#define    KPM_CLK_MGR_REG_POLICY3_MASK_USBH2_POLICY3_MASK_SHIFT          17
#define    KPM_CLK_MGR_REG_POLICY3_MASK_USBH2_POLICY3_MASK_MASK           0x00020000
#define    KPM_CLK_MGR_REG_POLICY3_MASK_HSIC2_POLICY3_MASK_SHIFT          16
#define    KPM_CLK_MGR_REG_POLICY3_MASK_HSIC2_POLICY3_MASK_MASK           0x00010000
#define    KPM_CLK_MGR_REG_POLICY3_MASK_APB8_POLICY3_MASK_SHIFT           13
#define    KPM_CLK_MGR_REG_POLICY3_MASK_APB8_POLICY3_MASK_MASK            0x00002000
#define    KPM_CLK_MGR_REG_POLICY3_MASK_ARMCORE_POLICY3_MASK_SHIFT        12
#define    KPM_CLK_MGR_REG_POLICY3_MASK_ARMCORE_POLICY3_MASK_MASK         0x00001000
#define    KPM_CLK_MGR_REG_POLICY3_MASK_USB_OTG_POLICY3_MASK_SHIFT        11
#define    KPM_CLK_MGR_REG_POLICY3_MASK_USB_OTG_POLICY3_MASK_MASK         0x00000800
#define    KPM_CLK_MGR_REG_POLICY3_MASK_USB_IC_POLICY3_MASK_SHIFT         9
#define    KPM_CLK_MGR_REG_POLICY3_MASK_USB_IC_POLICY3_MASK_MASK          0x00000200
#define    KPM_CLK_MGR_REG_POLICY3_MASK_NAND_POLICY3_MASK_SHIFT           7
#define    KPM_CLK_MGR_REG_POLICY3_MASK_NAND_POLICY3_MASK_MASK            0x00000080
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SDIO1_POLICY3_MASK_SHIFT          6
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SDIO1_POLICY3_MASK_MASK           0x00000040
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SDIO2_POLICY3_MASK_SHIFT          5
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SDIO2_POLICY3_MASK_MASK           0x00000020
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SDIO4_POLICY3_MASK_SHIFT          4
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SDIO4_POLICY3_MASK_MASK           0x00000010
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SDIO3_POLICY3_MASK_SHIFT          3
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SDIO3_POLICY3_MASK_MASK           0x00000008
#define    KPM_CLK_MGR_REG_POLICY3_MASK_MASTER_SWITCH_POLICY3_MASK_SHIFT  2
#define    KPM_CLK_MGR_REG_POLICY3_MASK_MASTER_SWITCH_POLICY3_MASK_MASK   0x00000004
#define    KPM_CLK_MGR_REG_POLICY3_MASK_DMA_POLICY3_MASK_SHIFT            1
#define    KPM_CLK_MGR_REG_POLICY3_MASK_DMA_POLICY3_MASK_MASK             0x00000002
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SYS_SWITCH_POLICY3_MASK_SHIFT     0
#define    KPM_CLK_MGR_REG_POLICY3_MASK_SYS_SWITCH_POLICY3_MASK_MASK      0x00000001

#define KPM_CLK_MGR_REG_INTEN_OFFSET                                      0x00000020
#define KPM_CLK_MGR_REG_INTEN_TYPE                                        UInt32
#define KPM_CLK_MGR_REG_INTEN_RESERVED_MASK                               0x7FFFFFFC
#define    KPM_CLK_MGR_REG_INTEN_PRIV_ACCESS_MODE_SHIFT                   31
#define    KPM_CLK_MGR_REG_INTEN_PRIV_ACCESS_MODE_MASK                    0x80000000
#define    KPM_CLK_MGR_REG_INTEN_INTEN_ACT_INT_EN_SHIFT                   1
#define    KPM_CLK_MGR_REG_INTEN_INTEN_ACT_INT_EN_MASK                    0x00000002
#define    KPM_CLK_MGR_REG_INTEN_INTEN_TGT_INT_EN_SHIFT                   0
#define    KPM_CLK_MGR_REG_INTEN_INTEN_TGT_INT_EN_MASK                    0x00000001

#define KPM_CLK_MGR_REG_INTSTAT_OFFSET                                    0x00000024
#define KPM_CLK_MGR_REG_INTSTAT_TYPE                                      UInt32
#define KPM_CLK_MGR_REG_INTSTAT_RESERVED_MASK                             0x7FFFFFFC
#define    KPM_CLK_MGR_REG_INTSTAT_PRIV_ACCESS_MODE_SHIFT                 31
#define    KPM_CLK_MGR_REG_INTSTAT_PRIV_ACCESS_MODE_MASK                  0x80000000
#define    KPM_CLK_MGR_REG_INTSTAT_INTSTAT_ACT_INT_SHIFT                  1
#define    KPM_CLK_MGR_REG_INTSTAT_INTSTAT_ACT_INT_MASK                   0x00000002
#define    KPM_CLK_MGR_REG_INTSTAT_INTSTAT_TGT_INT_SHIFT                  0
#define    KPM_CLK_MGR_REG_INTSTAT_INTSTAT_TGT_INT_MASK                   0x00000001

#define KPM_CLK_MGR_REG_VLT_PERI_OFFSET                                   0x00000030
#define KPM_CLK_MGR_REG_VLT_PERI_TYPE                                     UInt32
#define KPM_CLK_MGR_REG_VLT_PERI_RESERVED_MASK                            0x7FFFF0F0
#define    KPM_CLK_MGR_REG_VLT_PERI_PRIV_ACCESS_MODE_SHIFT                31
#define    KPM_CLK_MGR_REG_VLT_PERI_PRIV_ACCESS_MODE_MASK                 0x80000000
#define    KPM_CLK_MGR_REG_VLT_PERI_VLT_HIGH_PERI_SHIFT                   8
#define    KPM_CLK_MGR_REG_VLT_PERI_VLT_HIGH_PERI_MASK                    0x00000F00
#define    KPM_CLK_MGR_REG_VLT_PERI_VLT_NORMAL_PERI_SHIFT                 0
#define    KPM_CLK_MGR_REG_VLT_PERI_VLT_NORMAL_PERI_MASK                  0x0000000F

#define KPM_CLK_MGR_REG_LVM_EN_OFFSET                                     0x00000034
#define KPM_CLK_MGR_REG_LVM_EN_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_LVM_EN_RESERVED_MASK                              0x7FFFFFFE
#define    KPM_CLK_MGR_REG_LVM_EN_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_LVM_EN_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_LVM_EN_POLICY_CONFIG_EN_SHIFT                  0
#define    KPM_CLK_MGR_REG_LVM_EN_POLICY_CONFIG_EN_MASK                   0x00000001

#define KPM_CLK_MGR_REG_LVM0_3_OFFSET                                     0x00000038
#define KPM_CLK_MGR_REG_LVM0_3_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_LVM0_3_RESERVED_MASK                              0x7FFF0000
#define    KPM_CLK_MGR_REG_LVM0_3_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_LVM0_3_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_LVM0_3_LVM0_3_MD_03_SHIFT                      12
#define    KPM_CLK_MGR_REG_LVM0_3_LVM0_3_MD_03_MASK                       0x0000F000
#define    KPM_CLK_MGR_REG_LVM0_3_LVM0_3_MD_02_SHIFT                      8
#define    KPM_CLK_MGR_REG_LVM0_3_LVM0_3_MD_02_MASK                       0x00000F00
#define    KPM_CLK_MGR_REG_LVM0_3_LVM0_3_MD_01_SHIFT                      4
#define    KPM_CLK_MGR_REG_LVM0_3_LVM0_3_MD_01_MASK                       0x000000F0
#define    KPM_CLK_MGR_REG_LVM0_3_LVM0_3_MD_00_SHIFT                      0
#define    KPM_CLK_MGR_REG_LVM0_3_LVM0_3_MD_00_MASK                       0x0000000F

#define KPM_CLK_MGR_REG_LVM4_7_OFFSET                                     0x0000003C
#define KPM_CLK_MGR_REG_LVM4_7_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_LVM4_7_RESERVED_MASK                              0x7FFF0000
#define    KPM_CLK_MGR_REG_LVM4_7_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_LVM4_7_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_LVM4_7_LVM4_7_MD_07_SHIFT                      12
#define    KPM_CLK_MGR_REG_LVM4_7_LVM4_7_MD_07_MASK                       0x0000F000
#define    KPM_CLK_MGR_REG_LVM4_7_LVM4_7_MD_06_SHIFT                      8
#define    KPM_CLK_MGR_REG_LVM4_7_LVM4_7_MD_06_MASK                       0x00000F00
#define    KPM_CLK_MGR_REG_LVM4_7_LVM4_7_MD_05_SHIFT                      4
#define    KPM_CLK_MGR_REG_LVM4_7_LVM4_7_MD_05_MASK                       0x000000F0
#define    KPM_CLK_MGR_REG_LVM4_7_LVM4_7_MD_04_SHIFT                      0
#define    KPM_CLK_MGR_REG_LVM4_7_LVM4_7_MD_04_MASK                       0x0000000F

#define KPM_CLK_MGR_REG_VLT0_3_OFFSET                                     0x00000040
#define KPM_CLK_MGR_REG_VLT0_3_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_VLT0_3_RESERVED_MASK                              0x70F0F0F0
#define    KPM_CLK_MGR_REG_VLT0_3_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_VLT0_3_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_VLT0_3_VLT0_3_VV_03_SHIFT                      24
#define    KPM_CLK_MGR_REG_VLT0_3_VLT0_3_VV_03_MASK                       0x0F000000
#define    KPM_CLK_MGR_REG_VLT0_3_VLT0_3_VV_02_SHIFT                      16
#define    KPM_CLK_MGR_REG_VLT0_3_VLT0_3_VV_02_MASK                       0x000F0000
#define    KPM_CLK_MGR_REG_VLT0_3_VLT0_3_VV_01_SHIFT                      8
#define    KPM_CLK_MGR_REG_VLT0_3_VLT0_3_VV_01_MASK                       0x00000F00
#define    KPM_CLK_MGR_REG_VLT0_3_VLT0_3_VV_00_SHIFT                      0
#define    KPM_CLK_MGR_REG_VLT0_3_VLT0_3_VV_00_MASK                       0x0000000F

#define KPM_CLK_MGR_REG_VLT4_7_OFFSET                                     0x00000044
#define KPM_CLK_MGR_REG_VLT4_7_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_VLT4_7_RESERVED_MASK                              0x70F0F0F0
#define    KPM_CLK_MGR_REG_VLT4_7_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_VLT4_7_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_VLT4_7_VLT4_7_VV_07_SHIFT                      24
#define    KPM_CLK_MGR_REG_VLT4_7_VLT4_7_VV_07_MASK                       0x0F000000
#define    KPM_CLK_MGR_REG_VLT4_7_VLT4_7_VV_06_SHIFT                      16
#define    KPM_CLK_MGR_REG_VLT4_7_VLT4_7_VV_06_MASK                       0x000F0000
#define    KPM_CLK_MGR_REG_VLT4_7_VLT4_7_VV_05_SHIFT                      8
#define    KPM_CLK_MGR_REG_VLT4_7_VLT4_7_VV_05_MASK                       0x00000F00
#define    KPM_CLK_MGR_REG_VLT4_7_VLT4_7_VV_04_SHIFT                      0
#define    KPM_CLK_MGR_REG_VLT4_7_VLT4_7_VV_04_MASK                       0x0000000F

#define KPM_CLK_MGR_REG_BUS_QUIESC_OFFSET                                 0x00000100
#define KPM_CLK_MGR_REG_BUS_QUIESC_TYPE                                   UInt32
#define KPM_CLK_MGR_REG_BUS_QUIESC_RESERVED_MASK                          0x7FFFBFFF
#define    KPM_CLK_MGR_REG_BUS_QUIESC_PRIV_ACCESS_MODE_SHIFT              31
#define    KPM_CLK_MGR_REG_BUS_QUIESC_PRIV_ACCESS_MODE_MASK               0x80000000
#define    KPM_CLK_MGR_REG_BUS_QUIESC_SYS_SWITCH_AXI_SWITCH_REQGNT_INH_SHIFT 14
#define    KPM_CLK_MGR_REG_BUS_QUIESC_SYS_SWITCH_AXI_SWITCH_REQGNT_INH_MASK 0x00004000

#define KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_OFFSET                     0x00000200
#define KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_TYPE                       UInt32
#define KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_RESERVED_MASK              0x6FFEFCFD
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_PRIV_ACCESS_MODE_SHIFT  31
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_PRIV_ACCESS_MODE_MASK   0x80000000
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_SYS_SWITCH_VOLTAGE_LEVEL_SHIFT 28
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_SYS_SWITCH_VOLTAGE_LEVEL_MASK 0x10000000
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_SYS_SWITCH_AXI_STPRSTS_SHIFT 16
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_SYS_SWITCH_AXI_STPRSTS_MASK 0x00010000
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_SYS_SWITCH_AXI_HYST_EN_SHIFT 9
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_SYS_SWITCH_AXI_HYST_EN_MASK 0x00000200
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_SYS_SWITCH_AXI_HYST_VAL_SHIFT 8
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_SYS_SWITCH_AXI_HYST_VAL_MASK 0x00000100
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_SYS_SWITCH_AXI_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_AXI_SYS_SWITCH_CLKGATE_SYS_SWITCH_AXI_HW_SW_GATING_SEL_MASK 0x00000002

#define KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_OFFSET                     0x00000204
#define KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_TYPE                       UInt32
#define KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_RESERVED_MASK              0x6FFAF0F1
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_PRIV_ACCESS_MODE_SHIFT  31
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_PRIV_ACCESS_MODE_MASK   0x80000000
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_VOLTAGE_LEVEL_SHIFT 28
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_VOLTAGE_LEVEL_MASK 0x10000000
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AHB_STPRSTS_SHIFT 18
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AHB_STPRSTS_MASK 0x00040000
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AXI_STPRSTS_SHIFT 16
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AXI_STPRSTS_MASK 0x00010000
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AHB_HYST_EN_SHIFT 11
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AHB_HYST_EN_MASK 0x00000800
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AHB_HYST_VAL_SHIFT 10
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AHB_HYST_VAL_MASK 0x00000400
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AXI_HYST_EN_SHIFT 9
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AXI_HYST_EN_MASK 0x00000200
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AXI_HYST_VAL_SHIFT 8
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AXI_HYST_VAL_MASK 0x00000100
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AHB_HW_SW_GATING_SEL_SHIFT 3
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AHB_HW_SW_GATING_SEL_MASK 0x00000008
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AHB_CLK_EN_SHIFT 2
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AHB_CLK_EN_MASK 0x00000004
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AXI_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_AXI_MST_SWITCH_CLKGATE_MASTER_SWITCH_AXI_HW_SW_GATING_SEL_MASK 0x00000002

#define KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_OFFSET                           0x00000208
#define KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_TYPE                             UInt32
#define KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_RESERVED_MASK                    0x6FFEFCFC
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_PRIV_ACCESS_MODE_SHIFT        31
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_PRIV_ACCESS_MODE_MASK         0x80000000
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_VOLTAGE_LEVEL_SHIFT   28
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_VOLTAGE_LEVEL_MASK    0x10000000
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_AXI_STPRSTS_SHIFT     16
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_AXI_STPRSTS_MASK      0x00010000
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_AXI_HYST_EN_SHIFT     9
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_AXI_HYST_EN_MASK      0x00000200
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_AXI_HYST_VAL_SHIFT    8
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_AXI_HYST_VAL_MASK     0x00000100
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_AXI_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_AXI_HW_SW_GATING_SEL_MASK 0x00000002
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_AXI_CLK_EN_SHIFT      0
#define    KPM_CLK_MGR_REG_AXI_CORE_CLKGATE_ARMCORE_AXI_CLK_EN_MASK       0x00000001

#define KPM_CLK_MGR_REG_APB4_CLKGATE_OFFSET                               0x00000220
#define KPM_CLK_MGR_REG_APB4_CLKGATE_TYPE                                 UInt32
#define KPM_CLK_MGR_REG_APB4_CLKGATE_RESERVED_MASK                        0x7FFEFCFC
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_PRIV_ACCESS_MODE_SHIFT            31
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_PRIV_ACCESS_MODE_MASK             0x80000000
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_APB4_STPRSTS_SHIFT                16
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_APB4_STPRSTS_MASK                 0x00010000
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_APB4_HYST_EN_SHIFT                9
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_APB4_HYST_EN_MASK                 0x00000200
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_APB4_HYST_VAL_SHIFT               8
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_APB4_HYST_VAL_MASK                0x00000100
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_APB4_HW_SW_GATING_SEL_SHIFT       1
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_APB4_HW_SW_GATING_SEL_MASK        0x00000002
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_APB4_CLK_EN_SHIFT                 0
#define    KPM_CLK_MGR_REG_APB4_CLKGATE_APB4_CLK_EN_MASK                  0x00000001

#define KPM_CLK_MGR_REG_APB8_CLKGATE_OFFSET                               0x00000240
#define KPM_CLK_MGR_REG_APB8_CLKGATE_TYPE                                 UInt32
#define KPM_CLK_MGR_REG_APB8_CLKGATE_RESERVED_MASK                        0x6FFEFCFC
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_PRIV_ACCESS_MODE_SHIFT            31
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_PRIV_ACCESS_MODE_MASK             0x80000000
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_VOLTAGE_LEVEL_SHIFT          28
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_VOLTAGE_LEVEL_MASK           0x10000000
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_STPRSTS_SHIFT                16
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_STPRSTS_MASK                 0x00010000
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_HYST_EN_SHIFT                9
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_HYST_EN_MASK                 0x00000200
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_HYST_VAL_SHIFT               8
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_HYST_VAL_MASK                0x00000100
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_HW_SW_GATING_SEL_SHIFT       1
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_HW_SW_GATING_SEL_MASK        0x00000002
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_CLK_EN_SHIFT                 0
#define    KPM_CLK_MGR_REG_APB8_CLKGATE_APB8_CLK_EN_MASK                  0x00000001

#define KPM_CLK_MGR_REG_DMAC_CLKGATE_OFFSET                               0x00000300
#define KPM_CLK_MGR_REG_DMAC_CLKGATE_TYPE                                 UInt32
#define KPM_CLK_MGR_REG_DMAC_CLKGATE_RESERVED_MASK                        0x6FFEFCFC
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_PRIV_ACCESS_MODE_SHIFT            31
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_PRIV_ACCESS_MODE_MASK             0x80000000
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_VOLTAGE_LEVEL_SHIFT           28
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_VOLTAGE_LEVEL_MASK            0x10000000
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_AXI_STPRSTS_SHIFT             16
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_AXI_STPRSTS_MASK              0x00010000
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_AXI_HYST_EN_SHIFT             9
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_AXI_HYST_EN_MASK              0x00000200
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_AXI_HYST_VAL_SHIFT            8
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_AXI_HYST_VAL_MASK             0x00000100
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_AXI_HW_SW_GATING_SEL_SHIFT    1
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_AXI_HW_SW_GATING_SEL_MASK     0x00000002
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_AXI_CLK_EN_SHIFT              0
#define    KPM_CLK_MGR_REG_DMAC_CLKGATE_DMA_AXI_CLK_EN_MASK               0x00000001

#define KPM_CLK_MGR_REG_NAND_CLKGATE_OFFSET                               0x00000344
#define KPM_CLK_MGR_REG_NAND_CLKGATE_TYPE                                 UInt32
#define KPM_CLK_MGR_REG_NAND_CLKGATE_RESERVED_MASK                        0x6FFAFFF0
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_PRIV_ACCESS_MODE_SHIFT            31
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_PRIV_ACCESS_MODE_MASK             0x80000000
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_VOLTAGE_LEVEL_SHIFT          28
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_VOLTAGE_LEVEL_MASK           0x10000000
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_STPRSTS_SHIFT                18
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_STPRSTS_MASK                 0x00040000
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_AHB_STPRSTS_SHIFT            16
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_AHB_STPRSTS_MASK             0x00010000
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_HW_SW_GATING_SEL_SHIFT       3
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_HW_SW_GATING_SEL_MASK        0x00000008
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_CLK_EN_SHIFT                 2
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_CLK_EN_MASK                  0x00000004
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_AHB_HW_SW_GATING_SEL_SHIFT   1
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_AHB_HW_SW_GATING_SEL_MASK    0x00000002
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_AHB_CLK_EN_SHIFT             0
#define    KPM_CLK_MGR_REG_NAND_CLKGATE_NAND_AHB_CLK_EN_MASK              0x00000001

#define KPM_CLK_MGR_REG_USB_OTG_CLKGATE_OFFSET                            0x00000348
#define KPM_CLK_MGR_REG_USB_OTG_CLKGATE_TYPE                              UInt32
#define KPM_CLK_MGR_REG_USB_OTG_CLKGATE_RESERVED_MASK                     0x6FFEFFFC
#define    KPM_CLK_MGR_REG_USB_OTG_CLKGATE_PRIV_ACCESS_MODE_SHIFT         31
#define    KPM_CLK_MGR_REG_USB_OTG_CLKGATE_PRIV_ACCESS_MODE_MASK          0x80000000
#define    KPM_CLK_MGR_REG_USB_OTG_CLKGATE_USB_OTG_VOLTAGE_LEVEL_SHIFT    28
#define    KPM_CLK_MGR_REG_USB_OTG_CLKGATE_USB_OTG_VOLTAGE_LEVEL_MASK     0x10000000
#define    KPM_CLK_MGR_REG_USB_OTG_CLKGATE_USB_OTG_AHB_STPRSTS_SHIFT      16
#define    KPM_CLK_MGR_REG_USB_OTG_CLKGATE_USB_OTG_AHB_STPRSTS_MASK       0x00010000
#define    KPM_CLK_MGR_REG_USB_OTG_CLKGATE_USB_OTG_AHB_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_USB_OTG_CLKGATE_USB_OTG_AHB_HW_SW_GATING_SEL_MASK 0x00000002
#define    KPM_CLK_MGR_REG_USB_OTG_CLKGATE_USB_OTG_AHB_CLK_EN_SHIFT       0
#define    KPM_CLK_MGR_REG_USB_OTG_CLKGATE_USB_OTG_AHB_CLK_EN_MASK        0x00000001

#define KPM_CLK_MGR_REG_USB_IC_CLKGATE_OFFSET                             0x00000354
#define KPM_CLK_MGR_REG_USB_IC_CLKGATE_TYPE                               UInt32
#define KPM_CLK_MGR_REG_USB_IC_CLKGATE_RESERVED_MASK                      0x6FFAFFF0
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_PRIV_ACCESS_MODE_SHIFT          31
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_PRIV_ACCESS_MODE_MASK           0x80000000
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_VOLTAGE_LEVEL_SHIFT      28
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_VOLTAGE_LEVEL_MASK       0x10000000
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_STPRSTS_SHIFT            18
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_STPRSTS_MASK             0x00040000
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_AHB_STPRSTS_SHIFT        16
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_AHB_STPRSTS_MASK         0x00010000
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_HW_SW_GATING_SEL_SHIFT   3
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_HW_SW_GATING_SEL_MASK    0x00000008
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_CLK_EN_SHIFT             2
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_CLK_EN_MASK              0x00000004
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_AHB_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_AHB_HW_SW_GATING_SEL_MASK 0x00000002
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_AHB_CLK_EN_SHIFT         0
#define    KPM_CLK_MGR_REG_USB_IC_CLKGATE_USB_IC_AHB_CLK_EN_MASK          0x00000001

#define KPM_CLK_MGR_REG_SDIO1_CLKGATE_OFFSET                              0x00000358
#define KPM_CLK_MGR_REG_SDIO1_CLKGATE_TYPE                                UInt32
#define KPM_CLK_MGR_REG_SDIO1_CLKGATE_RESERVED_MASK                       0x6FEAFFE0
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_PRIV_ACCESS_MODE_SHIFT           31
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_PRIV_ACCESS_MODE_MASK            0x80000000
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_VOLTAGE_LEVEL_SHIFT        28
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_VOLTAGE_LEVEL_MASK         0x10000000
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_SLEEP_STPRSTS_SHIFT        20
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_SLEEP_STPRSTS_MASK         0x00100000
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_STPRSTS_SHIFT              18
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_STPRSTS_MASK               0x00040000
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_AHB_STPRSTS_SHIFT          16
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_AHB_STPRSTS_MASK           0x00010000
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_SLEEP_CLK_EN_SHIFT         4
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_SLEEP_CLK_EN_MASK          0x00000010
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_HW_SW_GATING_SEL_SHIFT     3
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_HW_SW_GATING_SEL_MASK      0x00000008
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_CLK_EN_SHIFT               2
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_CLK_EN_MASK                0x00000004
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_AHB_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_AHB_HW_SW_GATING_SEL_MASK  0x00000002
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_AHB_CLK_EN_SHIFT           0
#define    KPM_CLK_MGR_REG_SDIO1_CLKGATE_SDIO1_AHB_CLK_EN_MASK            0x00000001

#define KPM_CLK_MGR_REG_SDIO2_CLKGATE_OFFSET                              0x0000035C
#define KPM_CLK_MGR_REG_SDIO2_CLKGATE_TYPE                                UInt32
#define KPM_CLK_MGR_REG_SDIO2_CLKGATE_RESERVED_MASK                       0x6FEAFFE0
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_PRIV_ACCESS_MODE_SHIFT           31
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_PRIV_ACCESS_MODE_MASK            0x80000000
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_VOLTAGE_LEVEL_SHIFT        28
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_VOLTAGE_LEVEL_MASK         0x10000000
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_SLEEP_STPRSTS_SHIFT        20
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_SLEEP_STPRSTS_MASK         0x00100000
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_STPRSTS_SHIFT              18
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_STPRSTS_MASK               0x00040000
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_AHB_STPRSTS_SHIFT          16
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_AHB_STPRSTS_MASK           0x00010000
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_SLEEP_CLK_EN_SHIFT         4
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_SLEEP_CLK_EN_MASK          0x00000010
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_HW_SW_GATING_SEL_SHIFT     3
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_HW_SW_GATING_SEL_MASK      0x00000008
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_CLK_EN_SHIFT               2
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_CLK_EN_MASK                0x00000004
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_AHB_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_AHB_HW_SW_GATING_SEL_MASK  0x00000002
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_AHB_CLK_EN_SHIFT           0
#define    KPM_CLK_MGR_REG_SDIO2_CLKGATE_SDIO2_AHB_CLK_EN_MASK            0x00000001

#define KPM_CLK_MGR_REG_SDIO4_CLKGATE_OFFSET                              0x00000360
#define KPM_CLK_MGR_REG_SDIO4_CLKGATE_TYPE                                UInt32
#define KPM_CLK_MGR_REG_SDIO4_CLKGATE_RESERVED_MASK                       0x6FEAFFE0
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_PRIV_ACCESS_MODE_SHIFT           31
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_PRIV_ACCESS_MODE_MASK            0x80000000
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_VOLTAGE_LEVEL_SHIFT        28
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_VOLTAGE_LEVEL_MASK         0x10000000
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_SLEEP_STPRSTS_SHIFT        20
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_SLEEP_STPRSTS_MASK         0x00100000
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_STPRSTS_SHIFT              18
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_STPRSTS_MASK               0x00040000
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_AHB_STPRSTS_SHIFT          16
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_AHB_STPRSTS_MASK           0x00010000
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_SLEEP_CLK_EN_SHIFT         4
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_SLEEP_CLK_EN_MASK          0x00000010
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_HW_SW_GATING_SEL_SHIFT     3
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_HW_SW_GATING_SEL_MASK      0x00000008
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_CLK_EN_SHIFT               2
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_CLK_EN_MASK                0x00000004
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_AHB_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_AHB_HW_SW_GATING_SEL_MASK  0x00000002
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_AHB_CLK_EN_SHIFT           0
#define    KPM_CLK_MGR_REG_SDIO4_CLKGATE_SDIO4_AHB_CLK_EN_MASK            0x00000001

#define KPM_CLK_MGR_REG_SDIO3_CLKGATE_OFFSET                              0x00000364
#define KPM_CLK_MGR_REG_SDIO3_CLKGATE_TYPE                                UInt32
#define KPM_CLK_MGR_REG_SDIO3_CLKGATE_RESERVED_MASK                       0x6FEAFFE0
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_PRIV_ACCESS_MODE_SHIFT           31
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_PRIV_ACCESS_MODE_MASK            0x80000000
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_VOLTAGE_LEVEL_SHIFT        28
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_VOLTAGE_LEVEL_MASK         0x10000000
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_SLEEP_STPRSTS_SHIFT        20
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_SLEEP_STPRSTS_MASK         0x00100000
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_STPRSTS_SHIFT              18
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_STPRSTS_MASK               0x00040000
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_AHB_STPRSTS_SHIFT          16
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_AHB_STPRSTS_MASK           0x00010000
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_SLEEP_CLK_EN_SHIFT         4
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_SLEEP_CLK_EN_MASK          0x00000010
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_HW_SW_GATING_SEL_SHIFT     3
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_HW_SW_GATING_SEL_MASK      0x00000008
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_CLK_EN_SHIFT               2
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_CLK_EN_MASK                0x00000004
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_AHB_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_AHB_HW_SW_GATING_SEL_MASK  0x00000002
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_AHB_CLK_EN_SHIFT           0
#define    KPM_CLK_MGR_REG_SDIO3_CLKGATE_SDIO3_AHB_CLK_EN_MASK            0x00000001

#define KPM_CLK_MGR_REG_HSIC2_CLKGATE_OFFSET                              0x00000370
#define KPM_CLK_MGR_REG_HSIC2_CLKGATE_TYPE                                UInt32
#define KPM_CLK_MGR_REG_HSIC2_CLKGATE_RESERVED_MASK                       0x6FEAC3C0
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_PRIV_ACCESS_MODE_SHIFT           31
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_PRIV_ACCESS_MODE_MASK            0x80000000
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_VOLTAGE_LEVEL_SHIFT        28
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_VOLTAGE_LEVEL_MASK         0x10000000
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_12M_STPRSTS_SHIFT          20
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_12M_STPRSTS_MASK           0x00100000
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_48M_STPRSTS_SHIFT          18
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_48M_STPRSTS_MASK           0x00040000
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_AHB_STPRSTS_SHIFT          16
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_AHB_STPRSTS_MASK           0x00010000
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_12M_HYST_VAL_SHIFT         13
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_12M_HYST_VAL_MASK          0x00002000
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_12M_HYST_EN_SHIFT          12
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_12M_HYST_EN_MASK           0x00001000
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_48M_HYST_VAL_SHIFT         11
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_48M_HYST_VAL_MASK          0x00000800
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_48M_HYST_EN_SHIFT          10
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_48M_HYST_EN_MASK           0x00000400
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_12M_HW_SW_GATING_SEL_SHIFT 5
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_12M_HW_SW_GATING_SEL_MASK  0x00000020
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_12M_CLK_EN_SHIFT           4
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_12M_CLK_EN_MASK            0x00000010
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_48M_HW_SW_GATING_SEL_SHIFT 3
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_48M_HW_SW_GATING_SEL_MASK  0x00000008
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_48M_CLK_EN_SHIFT           2
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_48M_CLK_EN_MASK            0x00000004
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_AHB_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_AHB_HW_SW_GATING_SEL_MASK  0x00000002
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_AHB_CLK_EN_SHIFT           0
#define    KPM_CLK_MGR_REG_HSIC2_CLKGATE_HSIC2_AHB_CLK_EN_MASK            0x00000001

#define KPM_CLK_MGR_REG_USBH2_CLKGATE_OFFSET                              0x00000374
#define KPM_CLK_MGR_REG_USBH2_CLKGATE_TYPE                                UInt32
#define KPM_CLK_MGR_REG_USBH2_CLKGATE_RESERVED_MASK                       0x6FFEFFFC
#define    KPM_CLK_MGR_REG_USBH2_CLKGATE_PRIV_ACCESS_MODE_SHIFT           31
#define    KPM_CLK_MGR_REG_USBH2_CLKGATE_PRIV_ACCESS_MODE_MASK            0x80000000
#define    KPM_CLK_MGR_REG_USBH2_CLKGATE_USBH2_VOLTAGE_LEVEL_SHIFT        28
#define    KPM_CLK_MGR_REG_USBH2_CLKGATE_USBH2_VOLTAGE_LEVEL_MASK         0x10000000
#define    KPM_CLK_MGR_REG_USBH2_CLKGATE_USBH2_AHB_STPRSTS_SHIFT          16
#define    KPM_CLK_MGR_REG_USBH2_CLKGATE_USBH2_AHB_STPRSTS_MASK           0x00010000
#define    KPM_CLK_MGR_REG_USBH2_CLKGATE_USBH2_AHB_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_USBH2_CLKGATE_USBH2_AHB_HW_SW_GATING_SEL_MASK  0x00000002
#define    KPM_CLK_MGR_REG_USBH2_CLKGATE_USBH2_AHB_CLK_EN_SHIFT           0
#define    KPM_CLK_MGR_REG_USBH2_CLKGATE_USBH2_AHB_CLK_EN_MASK            0x00000001

#define KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_OFFSET                          0x00000378
#define KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_TYPE                            UInt32
#define KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_RESERVED_MASK                   0x6FFEFFFC
#define    KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_PRIV_ACCESS_MODE_SHIFT       31
#define    KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_PRIV_ACCESS_MODE_MASK        0x80000000
#define    KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_SPI_SLAVE_VOLTAGE_LEVEL_SHIFT 28
#define    KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_SPI_SLAVE_VOLTAGE_LEVEL_MASK 0x10000000
#define    KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_SPI_SLAVE_AHB_STPRSTS_SHIFT  16
#define    KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_SPI_SLAVE_AHB_STPRSTS_MASK   0x00010000
#define    KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_SPI_SLAVE_AHB_HW_SW_GATING_SEL_SHIFT 1
#define    KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_SPI_SLAVE_AHB_HW_SW_GATING_SEL_MASK 0x00000002
#define    KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_SPI_SLAVE_AHB_CLK_EN_SHIFT   0
#define    KPM_CLK_MGR_REG_SPI_SLAVE_CLKGATE_SPI_SLAVE_AHB_CLK_EN_MASK    0x00000001

#define KPM_CLK_MGR_REG_NAND_DIV_OFFSET                                   0x00000A14
#define KPM_CLK_MGR_REG_NAND_DIV_TYPE                                     UInt32
#define KPM_CLK_MGR_REG_NAND_DIV_RESERVED_MASK                            0x7FFFFF0C
#define    KPM_CLK_MGR_REG_NAND_DIV_PRIV_ACCESS_MODE_SHIFT                31
#define    KPM_CLK_MGR_REG_NAND_DIV_PRIV_ACCESS_MODE_MASK                 0x80000000
#define    KPM_CLK_MGR_REG_NAND_DIV_NAND_DIV_SHIFT                        4
#define    KPM_CLK_MGR_REG_NAND_DIV_NAND_DIV_MASK                         0x000000F0
#define    KPM_CLK_MGR_REG_NAND_DIV_NAND_PLL_SELECT_SHIFT                 0
#define    KPM_CLK_MGR_REG_NAND_DIV_NAND_PLL_SELECT_MASK                  0x00000003
#define       KPM_CLK_MGR_REG_NAND_DIV_NAND_PLL_SELECT_CMD_REF_CRYSTAL_CLK 0x00000000
#define       KPM_CLK_MGR_REG_NAND_DIV_NAND_PLL_SELECT_CMD_VAR_312M_CLK   0x00000001
#define       KPM_CLK_MGR_REG_NAND_DIV_NAND_PLL_SELECT_CMD_VAR_208M_CLK   0x00000002

#define KPM_CLK_MGR_REG_USB_IC_DIV_OFFSET                                 0x00000A24
#define KPM_CLK_MGR_REG_USB_IC_DIV_TYPE                                   UInt32
#define KPM_CLK_MGR_REG_USB_IC_DIV_RESERVED_MASK                          0x7FFFFFFC
#define    KPM_CLK_MGR_REG_USB_IC_DIV_PRIV_ACCESS_MODE_SHIFT              31
#define    KPM_CLK_MGR_REG_USB_IC_DIV_PRIV_ACCESS_MODE_MASK               0x80000000
#define    KPM_CLK_MGR_REG_USB_IC_DIV_USB_IC_PLL_SELECT_SHIFT             0
#define    KPM_CLK_MGR_REG_USB_IC_DIV_USB_IC_PLL_SELECT_MASK              0x00000003
#define       KPM_CLK_MGR_REG_USB_IC_DIV_USB_IC_PLL_SELECT_CMD_REF_CRYSTAL_CLK 0x00000000
#define       KPM_CLK_MGR_REG_USB_IC_DIV_USB_IC_PLL_SELECT_CMD_VAR_96M_CLK 0x00000001
#define       KPM_CLK_MGR_REG_USB_IC_DIV_USB_IC_PLL_SELECT_CMD_REF_96M_CLK 0x00000002

#define KPM_CLK_MGR_REG_SDIO1_DIV_OFFSET                                  0x00000A28
#define KPM_CLK_MGR_REG_SDIO1_DIV_TYPE                                    UInt32
#define KPM_CLK_MGR_REG_SDIO1_DIV_RESERVED_MASK                           0x7FFC0008
#define    KPM_CLK_MGR_REG_SDIO1_DIV_PRIV_ACCESS_MODE_SHIFT               31
#define    KPM_CLK_MGR_REG_SDIO1_DIV_PRIV_ACCESS_MODE_MASK                0x80000000
#define    KPM_CLK_MGR_REG_SDIO1_DIV_SDIO1_DIV_SHIFT                      4
#define    KPM_CLK_MGR_REG_SDIO1_DIV_SDIO1_DIV_MASK                       0x0003FFF0
#define    KPM_CLK_MGR_REG_SDIO1_DIV_SDIO1_PLL_SELECT_SHIFT               0
#define    KPM_CLK_MGR_REG_SDIO1_DIV_SDIO1_PLL_SELECT_MASK                0x00000007
#define       KPM_CLK_MGR_REG_SDIO1_DIV_SDIO1_PLL_SELECT_CMD_REF_CRYSTAL_CLK 0x00000000
#define       KPM_CLK_MGR_REG_SDIO1_DIV_SDIO1_PLL_SELECT_CMD_VAR_52M_CLK  0x00000001
#define       KPM_CLK_MGR_REG_SDIO1_DIV_SDIO1_PLL_SELECT_CMD_REF_52M_CLK  0x00000002
#define       KPM_CLK_MGR_REG_SDIO1_DIV_SDIO1_PLL_SELECT_CMD_VAR_96M_CLK  0x00000003
#define       KPM_CLK_MGR_REG_SDIO1_DIV_SDIO1_PLL_SELECT_CMD_REF_96M_CLK  0x00000004

#define KPM_CLK_MGR_REG_SDIO2_DIV_OFFSET                                  0x00000A2C
#define KPM_CLK_MGR_REG_SDIO2_DIV_TYPE                                    UInt32
#define KPM_CLK_MGR_REG_SDIO2_DIV_RESERVED_MASK                           0x7FFC0008
#define    KPM_CLK_MGR_REG_SDIO2_DIV_PRIV_ACCESS_MODE_SHIFT               31
#define    KPM_CLK_MGR_REG_SDIO2_DIV_PRIV_ACCESS_MODE_MASK                0x80000000
#define    KPM_CLK_MGR_REG_SDIO2_DIV_SDIO2_DIV_SHIFT                      4
#define    KPM_CLK_MGR_REG_SDIO2_DIV_SDIO2_DIV_MASK                       0x0003FFF0
#define    KPM_CLK_MGR_REG_SDIO2_DIV_SDIO2_PLL_SELECT_SHIFT               0
#define    KPM_CLK_MGR_REG_SDIO2_DIV_SDIO2_PLL_SELECT_MASK                0x00000007
#define       KPM_CLK_MGR_REG_SDIO2_DIV_SDIO2_PLL_SELECT_CMD_REF_CRYSTAL_CLK 0x00000000
#define       KPM_CLK_MGR_REG_SDIO2_DIV_SDIO2_PLL_SELECT_CMD_VAR_52M_CLK  0x00000001
#define       KPM_CLK_MGR_REG_SDIO2_DIV_SDIO2_PLL_SELECT_CMD_REF_52M_CLK  0x00000002
#define       KPM_CLK_MGR_REG_SDIO2_DIV_SDIO2_PLL_SELECT_CMD_VAR_96M_CLK  0x00000003
#define       KPM_CLK_MGR_REG_SDIO2_DIV_SDIO2_PLL_SELECT_CMD_REF_96M_CLK  0x00000004

#define KPM_CLK_MGR_REG_SDIO4_DIV_OFFSET                                  0x00000A30
#define KPM_CLK_MGR_REG_SDIO4_DIV_TYPE                                    UInt32
#define KPM_CLK_MGR_REG_SDIO4_DIV_RESERVED_MASK                           0x7FFC0008
#define    KPM_CLK_MGR_REG_SDIO4_DIV_PRIV_ACCESS_MODE_SHIFT               31
#define    KPM_CLK_MGR_REG_SDIO4_DIV_PRIV_ACCESS_MODE_MASK                0x80000000
#define    KPM_CLK_MGR_REG_SDIO4_DIV_SDIO4_DIV_SHIFT                      4
#define    KPM_CLK_MGR_REG_SDIO4_DIV_SDIO4_DIV_MASK                       0x0003FFF0
#define    KPM_CLK_MGR_REG_SDIO4_DIV_SDIO4_PLL_SELECT_SHIFT               0
#define    KPM_CLK_MGR_REG_SDIO4_DIV_SDIO4_PLL_SELECT_MASK                0x00000007
#define       KPM_CLK_MGR_REG_SDIO4_DIV_SDIO4_PLL_SELECT_CMD_REF_CRYSTAL_CLK 0x00000000
#define       KPM_CLK_MGR_REG_SDIO4_DIV_SDIO4_PLL_SELECT_CMD_VAR_52M_CLK  0x00000001
#define       KPM_CLK_MGR_REG_SDIO4_DIV_SDIO4_PLL_SELECT_CMD_REF_52M_CLK  0x00000002
#define       KPM_CLK_MGR_REG_SDIO4_DIV_SDIO4_PLL_SELECT_CMD_VAR_96M_CLK  0x00000003
#define       KPM_CLK_MGR_REG_SDIO4_DIV_SDIO4_PLL_SELECT_CMD_REF_96M_CLK  0x00000004

#define KPM_CLK_MGR_REG_SDIO3_DIV_OFFSET                                  0x00000A34
#define KPM_CLK_MGR_REG_SDIO3_DIV_TYPE                                    UInt32
#define KPM_CLK_MGR_REG_SDIO3_DIV_RESERVED_MASK                           0x7FFC0008
#define    KPM_CLK_MGR_REG_SDIO3_DIV_PRIV_ACCESS_MODE_SHIFT               31
#define    KPM_CLK_MGR_REG_SDIO3_DIV_PRIV_ACCESS_MODE_MASK                0x80000000
#define    KPM_CLK_MGR_REG_SDIO3_DIV_SDIO3_DIV_SHIFT                      4
#define    KPM_CLK_MGR_REG_SDIO3_DIV_SDIO3_DIV_MASK                       0x0003FFF0
#define    KPM_CLK_MGR_REG_SDIO3_DIV_SDIO3_PLL_SELECT_SHIFT               0
#define    KPM_CLK_MGR_REG_SDIO3_DIV_SDIO3_PLL_SELECT_MASK                0x00000007
#define       KPM_CLK_MGR_REG_SDIO3_DIV_SDIO3_PLL_SELECT_CMD_REF_CRYSTAL_CLK 0x00000000
#define       KPM_CLK_MGR_REG_SDIO3_DIV_SDIO3_PLL_SELECT_CMD_VAR_52M_CLK  0x00000001
#define       KPM_CLK_MGR_REG_SDIO3_DIV_SDIO3_PLL_SELECT_CMD_REF_52M_CLK  0x00000002
#define       KPM_CLK_MGR_REG_SDIO3_DIV_SDIO3_PLL_SELECT_CMD_VAR_96M_CLK  0x00000003
#define       KPM_CLK_MGR_REG_SDIO3_DIV_SDIO3_PLL_SELECT_CMD_REF_96M_CLK  0x00000004

#define KPM_CLK_MGR_REG_HSIC2_DIV_OFFSET                                  0x00000A38
#define KPM_CLK_MGR_REG_HSIC2_DIV_TYPE                                    UInt32
#define KPM_CLK_MGR_REG_HSIC2_DIV_RESERVED_MASK                           0x7FFFCFFC
#define    KPM_CLK_MGR_REG_HSIC2_DIV_PRIV_ACCESS_MODE_SHIFT               31
#define    KPM_CLK_MGR_REG_HSIC2_DIV_PRIV_ACCESS_MODE_MASK                0x80000000
#define    KPM_CLK_MGR_REG_HSIC2_DIV_HSIC2_12M_DIV_SHIFT                  12
#define    KPM_CLK_MGR_REG_HSIC2_DIV_HSIC2_12M_DIV_MASK                   0x00003000
#define    KPM_CLK_MGR_REG_HSIC2_DIV_HSIC2_48M_PLL_SELECT_SHIFT           0
#define    KPM_CLK_MGR_REG_HSIC2_DIV_HSIC2_48M_PLL_SELECT_MASK            0x00000003
#define       KPM_CLK_MGR_REG_HSIC2_DIV_HSIC2_48M_PLL_SELECT_CMD_REF_CRYSTAL_CLK 0x00000000
#define       KPM_CLK_MGR_REG_HSIC2_DIV_HSIC2_48M_PLL_SELECT_CMD_VAR_96M_CLK 0x00000001
#define       KPM_CLK_MGR_REG_HSIC2_DIV_HSIC2_48M_PLL_SELECT_CMD_REF_96M_CLK 0x00000002

#define KPM_CLK_MGR_REG_DIV_TRIG_OFFSET                                   0x00000AFC
#define KPM_CLK_MGR_REG_DIV_TRIG_TYPE                                     UInt32
#define KPM_CLK_MGR_REG_DIV_TRIG_RESERVED_MASK                            0x7FFFE15B
#define    KPM_CLK_MGR_REG_DIV_TRIG_PRIV_ACCESS_MODE_SHIFT                31
#define    KPM_CLK_MGR_REG_DIV_TRIG_PRIV_ACCESS_MODE_MASK                 0x80000000
#define    KPM_CLK_MGR_REG_DIV_TRIG_SDIO3_TRIGGER_SHIFT                   12
#define    KPM_CLK_MGR_REG_DIV_TRIG_SDIO3_TRIGGER_MASK                    0x00001000
#define    KPM_CLK_MGR_REG_DIV_TRIG_SDIO4_TRIGGER_SHIFT                   11
#define    KPM_CLK_MGR_REG_DIV_TRIG_SDIO4_TRIGGER_MASK                    0x00000800
#define    KPM_CLK_MGR_REG_DIV_TRIG_SDIO2_TRIGGER_SHIFT                   10
#define    KPM_CLK_MGR_REG_DIV_TRIG_SDIO2_TRIGGER_MASK                    0x00000400
#define    KPM_CLK_MGR_REG_DIV_TRIG_SDIO1_TRIGGER_SHIFT                   9
#define    KPM_CLK_MGR_REG_DIV_TRIG_SDIO1_TRIGGER_MASK                    0x00000200
#define    KPM_CLK_MGR_REG_DIV_TRIG_USB_IC_TRIGGER_SHIFT                  7
#define    KPM_CLK_MGR_REG_DIV_TRIG_USB_IC_TRIGGER_MASK                   0x00000080
#define    KPM_CLK_MGR_REG_DIV_TRIG_HSIC2_48M_TRIGGER_SHIFT               5
#define    KPM_CLK_MGR_REG_DIV_TRIG_HSIC2_48M_TRIGGER_MASK                0x00000020
#define    KPM_CLK_MGR_REG_DIV_TRIG_NAND_TRIGGER_SHIFT                    2
#define    KPM_CLK_MGR_REG_DIV_TRIG_NAND_TRIGGER_MASK                     0x00000004

#define KPM_CLK_MGR_REG_DEBUG0_OFFSET                                     0x00000E00
#define KPM_CLK_MGR_REG_DEBUG0_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_DEBUG0_RESERVED_MASK                              0x7FFFFFC0
#define    KPM_CLK_MGR_REG_DEBUG0_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_DEBUG0_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_DEBUG0_APB8_POLICY_OVERRIDE_SHIFT              5
#define    KPM_CLK_MGR_REG_DEBUG0_APB8_POLICY_OVERRIDE_MASK               0x00000020
#define    KPM_CLK_MGR_REG_DEBUG0_ARMCORE_AXI_POLICY_OVERRIDE_SHIFT       4
#define    KPM_CLK_MGR_REG_DEBUG0_ARMCORE_AXI_POLICY_OVERRIDE_MASK        0x00000010
#define    KPM_CLK_MGR_REG_DEBUG0_MASTER_SWITCH_AHB_POLICY_OVERRIDE_SHIFT 3
#define    KPM_CLK_MGR_REG_DEBUG0_MASTER_SWITCH_AHB_POLICY_OVERRIDE_MASK  0x00000008
#define    KPM_CLK_MGR_REG_DEBUG0_DMA_AXI_POLICY_OVERRIDE_SHIFT           2
#define    KPM_CLK_MGR_REG_DEBUG0_DMA_AXI_POLICY_OVERRIDE_MASK            0x00000004
#define    KPM_CLK_MGR_REG_DEBUG0_MASTER_SWITCH_AXI_POLICY_OVERRIDE_SHIFT 1
#define    KPM_CLK_MGR_REG_DEBUG0_MASTER_SWITCH_AXI_POLICY_OVERRIDE_MASK  0x00000002
#define    KPM_CLK_MGR_REG_DEBUG0_SYS_SWITCH_AXI_POLICY_OVERRIDE_SHIFT    0
#define    KPM_CLK_MGR_REG_DEBUG0_SYS_SWITCH_AXI_POLICY_OVERRIDE_MASK     0x00000001

#define KPM_CLK_MGR_REG_DEBUG1_OFFSET                                     0x00000E04
#define KPM_CLK_MGR_REG_DEBUG1_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_DEBUG1_RESERVED_MASK                              0x7FFFC419
#define    KPM_CLK_MGR_REG_DEBUG1_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_DEBUG1_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_DEBUG1_SPI_SLAVE_AHB_POLICY_OVERRIDE_SHIFT     13
#define    KPM_CLK_MGR_REG_DEBUG1_SPI_SLAVE_AHB_POLICY_OVERRIDE_MASK      0x00002000
#define    KPM_CLK_MGR_REG_DEBUG1_USBH2_AHB_POLICY_OVERRIDE_SHIFT         12
#define    KPM_CLK_MGR_REG_DEBUG1_USBH2_AHB_POLICY_OVERRIDE_MASK          0x00001000
#define    KPM_CLK_MGR_REG_DEBUG1_HSIC2_AHB_POLICY_OVERRIDE_SHIFT         11
#define    KPM_CLK_MGR_REG_DEBUG1_HSIC2_AHB_POLICY_OVERRIDE_MASK          0x00000800
#define    KPM_CLK_MGR_REG_DEBUG1_SDIO3_AHB_POLICY_OVERRIDE_SHIFT         9
#define    KPM_CLK_MGR_REG_DEBUG1_SDIO3_AHB_POLICY_OVERRIDE_MASK          0x00000200
#define    KPM_CLK_MGR_REG_DEBUG1_SDIO4_AHB_POLICY_OVERRIDE_SHIFT         8
#define    KPM_CLK_MGR_REG_DEBUG1_SDIO4_AHB_POLICY_OVERRIDE_MASK          0x00000100
#define    KPM_CLK_MGR_REG_DEBUG1_SDIO2_AHB_POLICY_OVERRIDE_SHIFT         7
#define    KPM_CLK_MGR_REG_DEBUG1_SDIO2_AHB_POLICY_OVERRIDE_MASK          0x00000080
#define    KPM_CLK_MGR_REG_DEBUG1_SDIO1_AHB_POLICY_OVERRIDE_SHIFT         6
#define    KPM_CLK_MGR_REG_DEBUG1_SDIO1_AHB_POLICY_OVERRIDE_MASK          0x00000040
#define    KPM_CLK_MGR_REG_DEBUG1_USB_IC_AHB_POLICY_OVERRIDE_SHIFT        5
#define    KPM_CLK_MGR_REG_DEBUG1_USB_IC_AHB_POLICY_OVERRIDE_MASK         0x00000020
#define    KPM_CLK_MGR_REG_DEBUG1_USB_OTG_AHB_POLICY_OVERRIDE_SHIFT       2
#define    KPM_CLK_MGR_REG_DEBUG1_USB_OTG_AHB_POLICY_OVERRIDE_MASK        0x00000004
#define    KPM_CLK_MGR_REG_DEBUG1_NAND_AHB_POLICY_OVERRIDE_SHIFT          1
#define    KPM_CLK_MGR_REG_DEBUG1_NAND_AHB_POLICY_OVERRIDE_MASK           0x00000002

#define KPM_CLK_MGR_REG_DEBUG2_OFFSET                                     0x00000E08
#define KPM_CLK_MGR_REG_DEBUG2_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_DEBUG2_RESERVED_MASK                              0x7FFFC07D
#define    KPM_CLK_MGR_REG_DEBUG2_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_DEBUG2_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_DEBUG2_HSIC2_12M_POLICY_OVERRIDE_SHIFT         13
#define    KPM_CLK_MGR_REG_DEBUG2_HSIC2_12M_POLICY_OVERRIDE_MASK          0x00002000
#define    KPM_CLK_MGR_REG_DEBUG2_HSIC2_48M_POLICY_OVERRIDE_SHIFT         12
#define    KPM_CLK_MGR_REG_DEBUG2_HSIC2_48M_POLICY_OVERRIDE_MASK          0x00001000
#define    KPM_CLK_MGR_REG_DEBUG2_SDIO3_POLICY_OVERRIDE_SHIFT             11
#define    KPM_CLK_MGR_REG_DEBUG2_SDIO3_POLICY_OVERRIDE_MASK              0x00000800
#define    KPM_CLK_MGR_REG_DEBUG2_SDIO4_POLICY_OVERRIDE_SHIFT             10
#define    KPM_CLK_MGR_REG_DEBUG2_SDIO4_POLICY_OVERRIDE_MASK              0x00000400
#define    KPM_CLK_MGR_REG_DEBUG2_SDIO2_POLICY_OVERRIDE_SHIFT             9
#define    KPM_CLK_MGR_REG_DEBUG2_SDIO2_POLICY_OVERRIDE_MASK              0x00000200
#define    KPM_CLK_MGR_REG_DEBUG2_SDIO1_POLICY_OVERRIDE_SHIFT             8
#define    KPM_CLK_MGR_REG_DEBUG2_SDIO1_POLICY_OVERRIDE_MASK              0x00000100
#define    KPM_CLK_MGR_REG_DEBUG2_USB_IC_POLICY_OVERRIDE_SHIFT            7
#define    KPM_CLK_MGR_REG_DEBUG2_USB_IC_POLICY_OVERRIDE_MASK             0x00000080
#define    KPM_CLK_MGR_REG_DEBUG2_NAND_POLICY_OVERRIDE_SHIFT              1
#define    KPM_CLK_MGR_REG_DEBUG2_NAND_POLICY_OVERRIDE_MASK               0x00000002

#define KPM_CLK_MGR_REG_DEBUG4_OFFSET                                     0x00000E10
#define KPM_CLK_MGR_REG_DEBUG4_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_DEBUG4_RESERVED_MASK                              0x7FFFFF00
#define    KPM_CLK_MGR_REG_DEBUG4_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_DEBUG4_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_DEBUG4_HSIC2_12M_POLICY_OVERRIDE_VALUE_SHIFT   7
#define    KPM_CLK_MGR_REG_DEBUG4_HSIC2_12M_POLICY_OVERRIDE_VALUE_MASK    0x00000080
#define    KPM_CLK_MGR_REG_DEBUG4_HSIC2_48M_POLICY_OVERRIDE_VALUE_SHIFT   6
#define    KPM_CLK_MGR_REG_DEBUG4_HSIC2_48M_POLICY_OVERRIDE_VALUE_MASK    0x00000040
#define    KPM_CLK_MGR_REG_DEBUG4_APB8_POLICY_OVERRIDE_VALUE_SHIFT        5
#define    KPM_CLK_MGR_REG_DEBUG4_APB8_POLICY_OVERRIDE_VALUE_MASK         0x00000020
#define    KPM_CLK_MGR_REG_DEBUG4_ARMCORE_AXI_POLICY_OVERRIDE_VALUE_SHIFT 4
#define    KPM_CLK_MGR_REG_DEBUG4_ARMCORE_AXI_POLICY_OVERRIDE_VALUE_MASK  0x00000010
#define    KPM_CLK_MGR_REG_DEBUG4_MASTER_SWITCH_AHB_POLICY_OVERRIDE_VALUE_SHIFT 3
#define    KPM_CLK_MGR_REG_DEBUG4_MASTER_SWITCH_AHB_POLICY_OVERRIDE_VALUE_MASK 0x00000008
#define    KPM_CLK_MGR_REG_DEBUG4_DMA_AXI_POLICY_OVERRIDE_VALUE_SHIFT     2
#define    KPM_CLK_MGR_REG_DEBUG4_DMA_AXI_POLICY_OVERRIDE_VALUE_MASK      0x00000004
#define    KPM_CLK_MGR_REG_DEBUG4_MASTER_SWITCH_AXI_POLICY_OVERRIDE_VALUE_SHIFT 1
#define    KPM_CLK_MGR_REG_DEBUG4_MASTER_SWITCH_AXI_POLICY_OVERRIDE_VALUE_MASK 0x00000002
#define    KPM_CLK_MGR_REG_DEBUG4_SYS_SWITCH_AXI_POLICY_OVERRIDE_VALUE_SHIFT 0
#define    KPM_CLK_MGR_REG_DEBUG4_SYS_SWITCH_AXI_POLICY_OVERRIDE_VALUE_MASK 0x00000001

#define KPM_CLK_MGR_REG_DEBUG5_OFFSET                                     0x00000E14
#define KPM_CLK_MGR_REG_DEBUG5_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_DEBUG5_RESERVED_MASK                              0x7FFFC419
#define    KPM_CLK_MGR_REG_DEBUG5_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_DEBUG5_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_DEBUG5_SPI_SLAVE_AHB_POLICY_OVERRIDE_VALUE_SHIFT 13
#define    KPM_CLK_MGR_REG_DEBUG5_SPI_SLAVE_AHB_POLICY_OVERRIDE_VALUE_MASK 0x00002000
#define    KPM_CLK_MGR_REG_DEBUG5_USBH2_AHB_POLICY_OVERRIDE_VALUE_SHIFT   12
#define    KPM_CLK_MGR_REG_DEBUG5_USBH2_AHB_POLICY_OVERRIDE_VALUE_MASK    0x00001000
#define    KPM_CLK_MGR_REG_DEBUG5_HSIC2_AHB_POLICY_OVERRIDE_VALUE_SHIFT   11
#define    KPM_CLK_MGR_REG_DEBUG5_HSIC2_AHB_POLICY_OVERRIDE_VALUE_MASK    0x00000800
#define    KPM_CLK_MGR_REG_DEBUG5_SDIO3_AHB_POLICY_OVERRIDE_VALUE_SHIFT   9
#define    KPM_CLK_MGR_REG_DEBUG5_SDIO3_AHB_POLICY_OVERRIDE_VALUE_MASK    0x00000200
#define    KPM_CLK_MGR_REG_DEBUG5_SDIO4_AHB_POLICY_OVERRIDE_VALUE_SHIFT   8
#define    KPM_CLK_MGR_REG_DEBUG5_SDIO4_AHB_POLICY_OVERRIDE_VALUE_MASK    0x00000100
#define    KPM_CLK_MGR_REG_DEBUG5_SDIO2_AHB_POLICY_OVERRIDE_VALUE_SHIFT   7
#define    KPM_CLK_MGR_REG_DEBUG5_SDIO2_AHB_POLICY_OVERRIDE_VALUE_MASK    0x00000080
#define    KPM_CLK_MGR_REG_DEBUG5_SDIO1_AHB_POLICY_OVERRIDE_VALUE_SHIFT   6
#define    KPM_CLK_MGR_REG_DEBUG5_SDIO1_AHB_POLICY_OVERRIDE_VALUE_MASK    0x00000040
#define    KPM_CLK_MGR_REG_DEBUG5_USB_IC_AHB_POLICY_OVERRIDE_VALUE_SHIFT  5
#define    KPM_CLK_MGR_REG_DEBUG5_USB_IC_AHB_POLICY_OVERRIDE_VALUE_MASK   0x00000020
#define    KPM_CLK_MGR_REG_DEBUG5_USB_OTG_AHB_POLICY_OVERRIDE_VALUE_SHIFT 2
#define    KPM_CLK_MGR_REG_DEBUG5_USB_OTG_AHB_POLICY_OVERRIDE_VALUE_MASK  0x00000004
#define    KPM_CLK_MGR_REG_DEBUG5_NAND_AHB_POLICY_OVERRIDE_VALUE_SHIFT    1
#define    KPM_CLK_MGR_REG_DEBUG5_NAND_AHB_POLICY_OVERRIDE_VALUE_MASK     0x00000002

#define KPM_CLK_MGR_REG_DEBUG6_OFFSET                                     0x00000E18
#define KPM_CLK_MGR_REG_DEBUG6_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_DEBUG6_RESERVED_MASK                              0x7FFFF07D
#define    KPM_CLK_MGR_REG_DEBUG6_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_DEBUG6_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_DEBUG6_SDIO3_POLICY_OVERRIDE_VALUE_SHIFT       11
#define    KPM_CLK_MGR_REG_DEBUG6_SDIO3_POLICY_OVERRIDE_VALUE_MASK        0x00000800
#define    KPM_CLK_MGR_REG_DEBUG6_SDIO4_POLICY_OVERRIDE_VALUE_SHIFT       10
#define    KPM_CLK_MGR_REG_DEBUG6_SDIO4_POLICY_OVERRIDE_VALUE_MASK        0x00000400
#define    KPM_CLK_MGR_REG_DEBUG6_SDIO2_POLICY_OVERRIDE_VALUE_SHIFT       9
#define    KPM_CLK_MGR_REG_DEBUG6_SDIO2_POLICY_OVERRIDE_VALUE_MASK        0x00000200
#define    KPM_CLK_MGR_REG_DEBUG6_SDIO1_POLICY_OVERRIDE_VALUE_SHIFT       8
#define    KPM_CLK_MGR_REG_DEBUG6_SDIO1_POLICY_OVERRIDE_VALUE_MASK        0x00000100
#define    KPM_CLK_MGR_REG_DEBUG6_USB_IC_POLICY_OVERRIDE_VALUE_SHIFT      7
#define    KPM_CLK_MGR_REG_DEBUG6_USB_IC_POLICY_OVERRIDE_VALUE_MASK       0x00000080
#define    KPM_CLK_MGR_REG_DEBUG6_NAND_POLICY_OVERRIDE_VALUE_SHIFT        1
#define    KPM_CLK_MGR_REG_DEBUG6_NAND_POLICY_OVERRIDE_VALUE_MASK         0x00000002

#define KPM_CLK_MGR_REG_DEBUG10_OFFSET                                    0x00000E28
#define KPM_CLK_MGR_REG_DEBUG10_TYPE                                      UInt32
#define KPM_CLK_MGR_REG_DEBUG10_RESERVED_MASK                             0x7FFFFFCC
#define    KPM_CLK_MGR_REG_DEBUG10_PRIV_ACCESS_MODE_SHIFT                 31
#define    KPM_CLK_MGR_REG_DEBUG10_PRIV_ACCESS_MODE_MASK                  0x80000000
#define    KPM_CLK_MGR_REG_DEBUG10_SYS_SWITCH_AXI_TRIGGER_OVERRIDE_SHIFT  5
#define    KPM_CLK_MGR_REG_DEBUG10_SYS_SWITCH_AXI_TRIGGER_OVERRIDE_MASK   0x00000020
#define    KPM_CLK_MGR_REG_DEBUG10_SYS_SWITCH_AXI_TRIGGER_SHIFT           4
#define    KPM_CLK_MGR_REG_DEBUG10_SYS_SWITCH_AXI_TRIGGER_MASK            0x00000010
#define    KPM_CLK_MGR_REG_DEBUG10_MASTER_SWITCH_AXI_CLK_EN_SHIFT         1
#define    KPM_CLK_MGR_REG_DEBUG10_MASTER_SWITCH_AXI_CLK_EN_MASK          0x00000002
#define    KPM_CLK_MGR_REG_DEBUG10_SYS_SWITCH_AXI_CLK_EN_SHIFT            0
#define    KPM_CLK_MGR_REG_DEBUG10_SYS_SWITCH_AXI_CLK_EN_MASK             0x00000001

#define KPM_CLK_MGR_REG_AXI_DIV_DEBUG_OFFSET                              0x00000E2C
#define KPM_CLK_MGR_REG_AXI_DIV_DEBUG_TYPE                                UInt32
#define KPM_CLK_MGR_REG_AXI_DIV_DEBUG_RESERVED_MASK                       0x428C83F8
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_PRIV_ACCESS_MODE_SHIFT           31
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_PRIV_ACCESS_MODE_MASK            0x80000000
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_APB8_DIV_OVERRIDE_SHIFT          29
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_APB8_DIV_OVERRIDE_MASK           0x20000000
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_ARMCORE_AXI_DIV_OVERRIDE_SHIFT   28
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_ARMCORE_AXI_DIV_OVERRIDE_MASK    0x10000000
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_APB4_FREE_DIV_OVERRIDE_SHIFT     27
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_APB4_FREE_DIV_OVERRIDE_MASK      0x08000000
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_MASTER_SWITCH_AHB_DIV_OVERRIDE_SHIFT 26
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_MASTER_SWITCH_AHB_DIV_OVERRIDE_MASK 0x04000000
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_SYS_SWITCH_AXI_PLL_SELECT_OVERRIDE_SHIFT 24
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_SYS_SWITCH_AXI_PLL_SELECT_OVERRIDE_MASK 0x01000000
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_APB8_DIV_SHIFT                   20
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_APB8_DIV_MASK                    0x00700000
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_ARMCORE_AXI_DIV_SHIFT            16
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_ARMCORE_AXI_DIV_MASK             0x00030000
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_APB4_FREE_DIV_SHIFT              12
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_APB4_FREE_DIV_MASK               0x00007000
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_MASTER_SWITCH_AHB_DIV_SHIFT      10
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_MASTER_SWITCH_AHB_DIV_MASK       0x00000C00
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_SYS_SWITCH_AXI_PLL_SELECT_SHIFT  0
#define    KPM_CLK_MGR_REG_AXI_DIV_DEBUG_SYS_SWITCH_AXI_PLL_SELECT_MASK   0x00000007
#define       KPM_CLK_MGR_REG_AXI_DIV_DEBUG_SYS_SWITCH_AXI_PLL_SELECT_CMD_REF_CRYSTAL_CLK 0x00000000
#define       KPM_CLK_MGR_REG_AXI_DIV_DEBUG_SYS_SWITCH_AXI_PLL_SELECT_CMD_VAR_312M_CLK 0x00000001
#define       KPM_CLK_MGR_REG_AXI_DIV_DEBUG_SYS_SWITCH_AXI_PLL_SELECT_CMD_VAR_156M_CLK 0x00000002
#define       KPM_CLK_MGR_REG_AXI_DIV_DEBUG_SYS_SWITCH_AXI_PLL_SELECT_CMD_VAR_208M_CLK 0x00000003
#define       KPM_CLK_MGR_REG_AXI_DIV_DEBUG_SYS_SWITCH_AXI_PLL_SELECT_CMD_VAR_52M_CLK 0x00000004
#define       KPM_CLK_MGR_REG_AXI_DIV_DEBUG_SYS_SWITCH_AXI_PLL_SELECT_CMD_VAR_104M_CLK 0x00000005
#define       KPM_CLK_MGR_REG_AXI_DIV_DEBUG_SYS_SWITCH_AXI_PLL_SELECT_CMD_VAR_78M_CLK 0x00000006

#define KPM_CLK_MGR_REG_CLKMON_OFFSET                                     0x00000E30
#define KPM_CLK_MGR_REG_CLKMON_TYPE                                       UInt32
#define KPM_CLK_MGR_REG_CLKMON_RESERVED_MASK                              0x7FFFFC00
#define    KPM_CLK_MGR_REG_CLKMON_PRIV_ACCESS_MODE_SHIFT                  31
#define    KPM_CLK_MGR_REG_CLKMON_PRIV_ACCESS_MODE_MASK                   0x80000000
#define    KPM_CLK_MGR_REG_CLKMON_CLKMON_CTL_SHIFT                        8
#define    KPM_CLK_MGR_REG_CLKMON_CLKMON_CTL_MASK                         0x00000300
#define    KPM_CLK_MGR_REG_CLKMON_CLKMON_SEL_SHIFT                        0
#define    KPM_CLK_MGR_REG_CLKMON_CLKMON_SEL_MASK                         0x000000FF

#define KPM_CLK_MGR_REG_SCAN_DIV1_OFFSET                                  0x00000E34
#define KPM_CLK_MGR_REG_SCAN_DIV1_TYPE                                    UInt32
#define KPM_CLK_MGR_REG_SCAN_DIV1_RESERVED_MASK                           0x4CCCF8FC
#define    KPM_CLK_MGR_REG_SCAN_DIV1_PRIV_ACCESS_MODE_SHIFT               31
#define    KPM_CLK_MGR_REG_SCAN_DIV1_PRIV_ACCESS_MODE_MASK                0x80000000
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN3_DIV_SHIFT                  28
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN3_DIV_MASK                   0x30000000
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN3_PLL_SELECT_SHIFT           24
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN3_PLL_SELECT_MASK            0x03000000
#define       KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN3_PLL_SELECT_CMD_VAR_312M_CLK 0x00000000
#define       KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN3_PLL_SELECT_CMD_VAR_208M_CLK 0x00000001
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN2_DIV_SHIFT                  20
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN2_DIV_MASK                   0x00300000
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN2_PLL_SELECT_SHIFT           16
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN2_PLL_SELECT_MASK            0x00030000
#define       KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN2_PLL_SELECT_CMD_VAR_312M_CLK 0x00000000
#define       KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN2_PLL_SELECT_CMD_VAR_208M_CLK 0x00000001
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN1_PLL_SELECT_SHIFT           8
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN1_PLL_SELECT_MASK            0x00000700
#define       KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN1_PLL_SELECT_CMD_VAR_156M_CLK 0x00000000
#define       KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN1_PLL_SELECT_CMD_VAR_104M_CLK 0x00000001
#define       KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN1_PLL_SELECT_CMD_VAR_78M_CLK 0x00000002
#define       KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN1_PLL_SELECT_CMD_DFT_52M_CLK 0x00000003
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN0_PLL_SELECT_SHIFT           0
#define    KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN0_PLL_SELECT_MASK            0x00000003
#define       KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN0_PLL_SELECT_CMD_VAR_104M_CLK 0x00000000
#define       KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN0_PLL_SELECT_CMD_VAR_78M_CLK 0x00000001
#define       KPM_CLK_MGR_REG_SCAN_DIV1_DFT_SCAN0_PLL_SELECT_CMD_DFT_52M_CLK 0x00000002

#define KPM_CLK_MGR_REG_SCAN_DIV2_OFFSET                                  0x00000E38
#define KPM_CLK_MGR_REG_SCAN_DIV2_TYPE                                    UInt32
#define KPM_CLK_MGR_REG_SCAN_DIV2_RESERVED_MASK                           0x7FFCCCFC
#define    KPM_CLK_MGR_REG_SCAN_DIV2_PRIV_ACCESS_MODE_SHIFT               31
#define    KPM_CLK_MGR_REG_SCAN_DIV2_PRIV_ACCESS_MODE_MASK                0x80000000
#define    KPM_CLK_MGR_REG_SCAN_DIV2_DFT_FAB_SS_PLL_SELECT_SHIFT          16
#define    KPM_CLK_MGR_REG_SCAN_DIV2_DFT_FAB_SS_PLL_SELECT_MASK           0x00030000
#define       KPM_CLK_MGR_REG_SCAN_DIV2_DFT_FAB_SS_PLL_SELECT_CMD_VAR_156M_CLK 0x00000000
#define       KPM_CLK_MGR_REG_SCAN_DIV2_DFT_FAB_SS_PLL_SELECT_CMD_VAR_208M_CLK 0x00000001
#define       KPM_CLK_MGR_REG_SCAN_DIV2_DFT_FAB_SS_PLL_SELECT_CMD_VAR_104M_CLK 0x00000002
#define    KPM_CLK_MGR_REG_SCAN_DIV2_DFT_SCAN14_DIV_SHIFT                 12
#define    KPM_CLK_MGR_REG_SCAN_DIV2_DFT_SCAN14_DIV_MASK                  0x00003000
#define    KPM_CLK_MGR_REG_SCAN_DIV2_DFT_SCAN14_PLL_SELECT_SHIFT          8
#define    KPM_CLK_MGR_REG_SCAN_DIV2_DFT_SCAN14_PLL_SELECT_MASK           0x00000300
#define       KPM_CLK_MGR_REG_SCAN_DIV2_DFT_SCAN14_PLL_SELECT_CMD_VAR_312M_CLK 0x00000000
#define       KPM_CLK_MGR_REG_SCAN_DIV2_DFT_SCAN14_PLL_SELECT_CMD_VAR_208M_CLK 0x00000001
#define    KPM_CLK_MGR_REG_SCAN_DIV2_DFT_HUB_SS_PLL_SELECT_SHIFT          0
#define    KPM_CLK_MGR_REG_SCAN_DIV2_DFT_HUB_SS_PLL_SELECT_MASK           0x00000003
#define       KPM_CLK_MGR_REG_SCAN_DIV2_DFT_HUB_SS_PLL_SELECT_CMD_VAR_156M_CLK 0x00000000
#define       KPM_CLK_MGR_REG_SCAN_DIV2_DFT_HUB_SS_PLL_SELECT_CMD_VAR_208M_CLK 0x00000001
#define       KPM_CLK_MGR_REG_SCAN_DIV2_DFT_HUB_SS_PLL_SELECT_CMD_VAR_104M_CLK 0x00000002

#define KPM_CLK_MGR_REG_DFT_DIV_TRIG_OFFSET                               0x00000E3C
#define KPM_CLK_MGR_REG_DFT_DIV_TRIG_TYPE                                 UInt32
#define KPM_CLK_MGR_REG_DFT_DIV_TRIG_RESERVED_MASK                        0x7FFF1FF0
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_PRIV_ACCESS_MODE_SHIFT            31
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_PRIV_ACCESS_MODE_MASK             0x80000000
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_FAB_SS_TRIGGER_SHIFT          15
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_FAB_SS_TRIGGER_MASK           0x00008000
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_SCAN14_TRIGGER_SHIFT          14
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_SCAN14_TRIGGER_MASK           0x00004000
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_HUB_SS_TRIGGER_SHIFT          13
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_HUB_SS_TRIGGER_MASK           0x00002000
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_SCAN3_TRIGGER_SHIFT           3
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_SCAN3_TRIGGER_MASK            0x00000008
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_SCAN2_TRIGGER_SHIFT           2
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_SCAN2_TRIGGER_MASK            0x00000004
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_SCAN1_TRIGGER_SHIFT           1
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_SCAN1_TRIGGER_MASK            0x00000002
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_SCAN0_TRIGGER_SHIFT           0
#define    KPM_CLK_MGR_REG_DFT_DIV_TRIG_DFT_SCAN0_TRIGGER_MASK            0x00000001

#define KPM_CLK_MGR_REG_ACTIVITY_MON1_OFFSET                              0x00000E40
#define KPM_CLK_MGR_REG_ACTIVITY_MON1_TYPE                                UInt32
#define KPM_CLK_MGR_REG_ACTIVITY_MON1_RESERVED_MASK                       0x40C01000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_PRIV_ACCESS_MODE_SHIFT           31
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_PRIV_ACCESS_MODE_MASK            0x80000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_HSIC2_12M_ACTVSTS_SHIFT          29
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_HSIC2_12M_ACTVSTS_MASK           0x20000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_HSIC2_48M_ACTVSTS_SHIFT          28
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_HSIC2_48M_ACTVSTS_MASK           0x10000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO4_SLEEP_ACTVSTS_SHIFT        27
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO4_SLEEP_ACTVSTS_MASK         0x08000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO3_SLEEP_ACTVSTS_SHIFT        26
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO3_SLEEP_ACTVSTS_MASK         0x04000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO2_SLEEP_ACTVSTS_SHIFT        25
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO2_SLEEP_ACTVSTS_MASK         0x02000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO1_SLEEP_ACTVSTS_SHIFT        24
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO1_SLEEP_ACTVSTS_MASK         0x01000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_USB_IC_ACTVSTS_SHIFT             21
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_USB_IC_ACTVSTS_MASK              0x00200000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_NAND_ACTVSTS_SHIFT               20
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_NAND_ACTVSTS_MASK                0x00100000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO1_ACTVSTS_SHIFT              19
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO1_ACTVSTS_MASK               0x00080000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO4_ACTVSTS_SHIFT              18
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO4_ACTVSTS_MASK               0x00040000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO3_ACTVSTS_SHIFT              17
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO3_ACTVSTS_MASK               0x00020000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO2_ACTVSTS_SHIFT              16
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO2_ACTVSTS_MASK               0x00010000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_APB8_ACTVSTS_SHIFT               15
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_APB8_ACTVSTS_MASK                0x00008000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_APB4_ACTVSTS_SHIFT               14
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_APB4_ACTVSTS_MASK                0x00004000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_APB4_FREE_ACTVSTS_SHIFT          13
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_APB4_FREE_ACTVSTS_MASK           0x00002000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_USB_OTG_AHB_ACTVSTS_SHIFT        11
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_USB_OTG_AHB_ACTVSTS_MASK         0x00000800
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_USB_IC_AHB_ACTVSTS_SHIFT         10
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_USB_IC_AHB_ACTVSTS_MASK          0x00000400
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_NAND_AHB_ACTVSTS_SHIFT           9
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_NAND_AHB_ACTVSTS_MASK            0x00000200
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO1_AHB_ACTVSTS_SHIFT          8
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO1_AHB_ACTVSTS_MASK           0x00000100
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO4_AHB_ACTVSTS_SHIFT          7
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO4_AHB_ACTVSTS_MASK           0x00000080
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO3_AHB_ACTVSTS_SHIFT          6
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO3_AHB_ACTVSTS_MASK           0x00000040
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO2_AHB_ACTVSTS_SHIFT          5
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SDIO2_AHB_ACTVSTS_MASK           0x00000020
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_MASTER_SWITCH_AXI_ACTVSTS_SHIFT  4
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_MASTER_SWITCH_AXI_ACTVSTS_MASK   0x00000010
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_MASTER_SWITCH_AHB_ACTVSTS_SHIFT  3
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_MASTER_SWITCH_AHB_ACTVSTS_MASK   0x00000008
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_ARMCORE_AXI_ACTVSTS_SHIFT        2
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_ARMCORE_AXI_ACTVSTS_MASK         0x00000004
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_DMA_AXI_ACTVSTS_SHIFT            1
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_DMA_AXI_ACTVSTS_MASK             0x00000002
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SYS_SWITCH_AXI_ACTVSTS_SHIFT     0
#define    KPM_CLK_MGR_REG_ACTIVITY_MON1_SYS_SWITCH_AXI_ACTVSTS_MASK      0x00000001

#define KPM_CLK_MGR_REG_ACTIVITY_MON2_OFFSET                              0x00000E44
#define KPM_CLK_MGR_REG_ACTIVITY_MON2_TYPE                                UInt32
#define KPM_CLK_MGR_REG_ACTIVITY_MON2_RESERVED_MASK                       0x00000385
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_PRIV_ACCESS_MODE_SHIFT           31
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_PRIV_ACCESS_MODE_MASK            0x80000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN20_ACTVSTS_SHIFT         30
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN20_ACTVSTS_MASK          0x40000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN19_ACTVSTS_SHIFT         29
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN19_ACTVSTS_MASK          0x20000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN18_ACTVSTS_SHIFT         28
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN18_ACTVSTS_MASK          0x10000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN17_ACTVSTS_SHIFT         27
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN17_ACTVSTS_MASK          0x08000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN16_ACTVSTS_SHIFT         26
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN16_ACTVSTS_MASK          0x04000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN15_ACTVSTS_SHIFT         25
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN15_ACTVSTS_MASK          0x02000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN14_ACTVSTS_SHIFT         24
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN14_ACTVSTS_MASK          0x01000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN13_ACTVSTS_SHIFT         23
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN13_ACTVSTS_MASK          0x00800000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN12_ACTVSTS_SHIFT         22
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN12_ACTVSTS_MASK          0x00400000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN11_ACTVSTS_SHIFT         21
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN11_ACTVSTS_MASK          0x00200000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN10_ACTVSTS_SHIFT         20
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN10_ACTVSTS_MASK          0x00100000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN9_ACTVSTS_SHIFT          19
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN9_ACTVSTS_MASK           0x00080000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN8_ACTVSTS_SHIFT          18
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN8_ACTVSTS_MASK           0x00040000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN7_ACTVSTS_SHIFT          17
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN7_ACTVSTS_MASK           0x00020000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN6_ACTVSTS_SHIFT          16
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN6_ACTVSTS_MASK           0x00010000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN5_ACTVSTS_SHIFT          15
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN5_ACTVSTS_MASK           0x00008000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN4_ACTVSTS_SHIFT          14
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN4_ACTVSTS_MASK           0x00004000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN3_ACTVSTS_SHIFT          13
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN3_ACTVSTS_MASK           0x00002000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN2_ACTVSTS_SHIFT          12
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN2_ACTVSTS_MASK           0x00001000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN1_ACTVSTS_SHIFT          11
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN1_ACTVSTS_MASK           0x00000800
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN0_ACTVSTS_SHIFT          10
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_DFT_SCAN0_ACTVSTS_MASK           0x00000400
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_VAR_78M_ACTVSTS_SHIFT            6
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_VAR_78M_ACTVSTS_MASK             0x00000040
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_VAR_156M_ACTVSTS_SHIFT           5
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_VAR_156M_ACTVSTS_MASK            0x00000020
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_VAR_104M_ACTVSTS_SHIFT           4
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_VAR_104M_ACTVSTS_MASK            0x00000010
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_VAR_52M_ACTVSTS_SHIFT            3
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_VAR_52M_ACTVSTS_MASK             0x00000008
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_REF_52M_ACTVSTS_SHIFT            1
#define    KPM_CLK_MGR_REG_ACTIVITY_MON2_REF_52M_ACTVSTS_MASK             0x00000002

#define KPM_CLK_MGR_REG_ACTIVITY_MON3_OFFSET                              0x00000E48
#define KPM_CLK_MGR_REG_ACTIVITY_MON3_TYPE                                UInt32
#define KPM_CLK_MGR_REG_ACTIVITY_MON3_RESERVED_MASK                       0x7FFF038F
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_PRIV_ACCESS_MODE_SHIFT           31
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_PRIV_ACCESS_MODE_MASK            0x80000000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_SCAN25_ACTVSTS_SHIFT         15
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_SCAN25_ACTVSTS_MASK          0x00008000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_SCAN24_ACTVSTS_SHIFT         14
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_SCAN24_ACTVSTS_MASK          0x00004000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_SCAN23_ACTVSTS_SHIFT         13
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_SCAN23_ACTVSTS_MASK          0x00002000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_SCAN22_ACTVSTS_SHIFT         12
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_SCAN22_ACTVSTS_MASK          0x00001000
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_SCAN21_ACTVSTS_SHIFT         11
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_SCAN21_ACTVSTS_MASK          0x00000800
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_52M_ACTVSTS_SHIFT            10
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_DFT_52M_ACTVSTS_MASK             0x00000400
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_SPI_SLAVE_AHB_ACTVSTS_SHIFT      6
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_SPI_SLAVE_AHB_ACTVSTS_MASK       0x00000040
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_USBH2_AHB_ACTVSTS_SHIFT          5
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_USBH2_AHB_ACTVSTS_MASK           0x00000020
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_HSIC2_AHB_ACTVSTS_SHIFT          4
#define    KPM_CLK_MGR_REG_ACTIVITY_MON3_HSIC2_AHB_ACTVSTS_MASK           0x00000010

#define KPM_CLK_MGR_REG_DEBUG_BUS_CTL_OFFSET                              0x00000EA0
#define KPM_CLK_MGR_REG_DEBUG_BUS_CTL_TYPE                                UInt32
#define KPM_CLK_MGR_REG_DEBUG_BUS_CTL_RESERVED_MASK                       0x7FFFFEE0
#define    KPM_CLK_MGR_REG_DEBUG_BUS_CTL_PRIV_ACCESS_MODE_SHIFT           31
#define    KPM_CLK_MGR_REG_DEBUG_BUS_CTL_PRIV_ACCESS_MODE_MASK            0x80000000
#define    KPM_CLK_MGR_REG_DEBUG_BUS_CTL_BUS_ERR_MASK_CTL_SHIFT           8
#define    KPM_CLK_MGR_REG_DEBUG_BUS_CTL_BUS_ERR_MASK_CTL_MASK            0x00000100
#define    KPM_CLK_MGR_REG_DEBUG_BUS_CTL_DEBUG_BUS_SEL_SHIFT              0
#define    KPM_CLK_MGR_REG_DEBUG_BUS_CTL_DEBUG_BUS_SEL_MASK               0x0000001F

#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS0_OFFSET                          0x00000EA4
#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS0_TYPE                            UInt32
#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS0_RESERVED_MASK                   0x70000000
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS0_PRIV_ACCESS_MODE_SHIFT       31
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS0_PRIV_ACCESS_MODE_MASK        0x80000000
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS0_DEBUG_BUS_STATUS0_SHIFT      0
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS0_DEBUG_BUS_STATUS0_MASK       0x0FFFFFFF

#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS1_OFFSET                          0x00000EA8
#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS1_TYPE                            UInt32
#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS1_RESERVED_MASK                   0x70000000
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS1_PRIV_ACCESS_MODE_SHIFT       31
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS1_PRIV_ACCESS_MODE_MASK        0x80000000
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS1_DEBUG_BUS_STATUS1_SHIFT      0
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS1_DEBUG_BUS_STATUS1_MASK       0x0FFFFFFF

#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS2_OFFSET                          0x00000EAC
#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS2_TYPE                            UInt32
#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS2_RESERVED_MASK                   0x70000000
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS2_PRIV_ACCESS_MODE_SHIFT       31
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS2_PRIV_ACCESS_MODE_MASK        0x80000000
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS2_DEBUG_BUS_STATUS2_SHIFT      0
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS2_DEBUG_BUS_STATUS2_MASK       0x0FFFFFFF

#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS3_OFFSET                          0x00000EB0
#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS3_TYPE                            UInt32
#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS3_RESERVED_MASK                   0x70000000
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS3_PRIV_ACCESS_MODE_SHIFT       31
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS3_PRIV_ACCESS_MODE_MASK        0x80000000
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS3_DEBUG_BUS_STATUS3_SHIFT      0
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS3_DEBUG_BUS_STATUS3_MASK       0x0FFFFFFF

#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS4_OFFSET                          0x00000EB4
#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS4_TYPE                            UInt32
#define KPM_CLK_MGR_REG_DEBUG_BUS_STATUS4_RESERVED_MASK                   0x7FFF0000
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS4_PRIV_ACCESS_MODE_SHIFT       31
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS4_PRIV_ACCESS_MODE_MASK        0x80000000
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS4_DEBUG_BUS_STATUS4_SHIFT      0
#define    KPM_CLK_MGR_REG_DEBUG_BUS_STATUS4_DEBUG_BUS_STATUS4_MASK       0x0000FFFF

#define KPM_CLK_MGR_REG_POLICY_DBG_OFFSET                                 0x00000EC0
#define KPM_CLK_MGR_REG_POLICY_DBG_TYPE                                   UInt32
#define KPM_CLK_MGR_REG_POLICY_DBG_RESERVED_MASK                          0x7FFF88CC
#define    KPM_CLK_MGR_REG_POLICY_DBG_PRIV_ACCESS_MODE_SHIFT              31
#define    KPM_CLK_MGR_REG_POLICY_DBG_PRIV_ACCESS_MODE_MASK               0x80000000
#define    KPM_CLK_MGR_REG_POLICY_DBG_ACT_FREQ_SHIFT                      12
#define    KPM_CLK_MGR_REG_POLICY_DBG_ACT_FREQ_MASK                       0x00007000
#define    KPM_CLK_MGR_REG_POLICY_DBG_TGT_FREQ_SHIFT                      8
#define    KPM_CLK_MGR_REG_POLICY_DBG_TGT_FREQ_MASK                       0x00000700
#define    KPM_CLK_MGR_REG_POLICY_DBG_ACT_POLICY_SHIFT                    4
#define    KPM_CLK_MGR_REG_POLICY_DBG_ACT_POLICY_MASK                     0x00000030
#define    KPM_CLK_MGR_REG_POLICY_DBG_TGT_POLICY_SHIFT                    0
#define    KPM_CLK_MGR_REG_POLICY_DBG_TGT_POLICY_MASK                     0x00000003

#define KPM_CLK_MGR_REG_TGTMASK_DBG1_OFFSET                               0x00000EC4
#define KPM_CLK_MGR_REG_TGTMASK_DBG1_TYPE                                 UInt32
#define KPM_CLK_MGR_REG_TGTMASK_DBG1_RESERVED_MASK                        0x7FFC6800
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_PRIV_ACCESS_MODE_SHIFT            31
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_PRIV_ACCESS_MODE_MASK             0x80000000
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SPI_SLAVE_TARGET_MASK_SHIFT       17
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SPI_SLAVE_TARGET_MASK_MASK        0x00020000
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_USBH2_TARGET_MASK_SHIFT           16
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_USBH2_TARGET_MASK_MASK            0x00010000
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_HSIC2_TARGET_MASK_SHIFT           15
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_HSIC2_TARGET_MASK_MASK            0x00008000
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_APB8_TARGET_MASK_SHIFT            12
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_APB8_TARGET_MASK_MASK             0x00001000
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_USB_OTG_TARGET_MASK_SHIFT         10
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_USB_OTG_TARGET_MASK_MASK          0x00000400
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_USB_IC_TARGET_MASK_SHIFT          9
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_USB_IC_TARGET_MASK_MASK           0x00000200
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_NAND_TARGET_MASK_SHIFT            8
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_NAND_TARGET_MASK_MASK             0x00000100
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SDIO1_TARGET_MASK_SHIFT           7
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SDIO1_TARGET_MASK_MASK            0x00000080
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SDIO4_TARGET_MASK_SHIFT           6
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SDIO4_TARGET_MASK_MASK            0x00000040
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SDIO3_TARGET_MASK_SHIFT           5
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SDIO3_TARGET_MASK_MASK            0x00000020
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SDIO2_TARGET_MASK_SHIFT           4
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SDIO2_TARGET_MASK_MASK            0x00000010
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_MASTER_SWITCH_TARGET_MASK_SHIFT   3
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_MASTER_SWITCH_TARGET_MASK_MASK    0x00000008
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_ARMCORE_TARGET_MASK_SHIFT         2
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_ARMCORE_TARGET_MASK_MASK          0x00000004
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_DMA_TARGET_MASK_SHIFT             1
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_DMA_TARGET_MASK_MASK              0x00000002
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SYS_SWITCH_TARGET_MASK_SHIFT      0
#define    KPM_CLK_MGR_REG_TGTMASK_DBG1_SYS_SWITCH_TARGET_MASK_MASK       0x00000001

#define KPM_CLK_MGR_REG_ACTMASK_DBG1_OFFSET                               0x00000ED4
#define KPM_CLK_MGR_REG_ACTMASK_DBG1_TYPE                                 UInt32
#define KPM_CLK_MGR_REG_ACTMASK_DBG1_RESERVED_MASK                        0x7FFC6800
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_PRIV_ACCESS_MODE_SHIFT            31
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_PRIV_ACCESS_MODE_MASK             0x80000000
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SPI_SLAVE_ACTIVE_MASK_SHIFT       17
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SPI_SLAVE_ACTIVE_MASK_MASK        0x00020000
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_USBH2_ACTIVE_MASK_SHIFT           16
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_USBH2_ACTIVE_MASK_MASK            0x00010000
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_HSIC2_ACTIVE_MASK_SHIFT           15
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_HSIC2_ACTIVE_MASK_MASK            0x00008000
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_APB8_ACTIVE_MASK_SHIFT            12
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_APB8_ACTIVE_MASK_MASK             0x00001000
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_USB_OTG_ACTIVE_MASK_SHIFT         10
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_USB_OTG_ACTIVE_MASK_MASK          0x00000400
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_USB_IC_ACTIVE_MASK_SHIFT          9
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_USB_IC_ACTIVE_MASK_MASK           0x00000200
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_NAND_ACTIVE_MASK_SHIFT            8
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_NAND_ACTIVE_MASK_MASK             0x00000100
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SDIO1_ACTIVE_MASK_SHIFT           7
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SDIO1_ACTIVE_MASK_MASK            0x00000080
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SDIO4_ACTIVE_MASK_SHIFT           6
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SDIO4_ACTIVE_MASK_MASK            0x00000040
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SDIO3_ACTIVE_MASK_SHIFT           5
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SDIO3_ACTIVE_MASK_MASK            0x00000020
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SDIO2_ACTIVE_MASK_SHIFT           4
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SDIO2_ACTIVE_MASK_MASK            0x00000010
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_MASTER_SWITCH_ACTIVE_MASK_SHIFT   3
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_MASTER_SWITCH_ACTIVE_MASK_MASK    0x00000008
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_ARMCORE_ACTIVE_MASK_SHIFT         2
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_ARMCORE_ACTIVE_MASK_MASK          0x00000004
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_DMA_ACTIVE_MASK_SHIFT             1
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_DMA_ACTIVE_MASK_MASK              0x00000002
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SYS_SWITCH_ACTIVE_MASK_SHIFT      0
#define    KPM_CLK_MGR_REG_ACTMASK_DBG1_SYS_SWITCH_ACTIVE_MASK_MASK       0x00000001

#endif /* __BRCM_RDB_KPM_CLK_MGR_REG_H__ */


