/*
 * Copyright 2016 Broadcom
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation (the "GPL").
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License version 2 (GPLv2) for more details.
 *
 * You should have received a copy of the GNU General Public License
 * version 2 (GPLv2) along with this source code.
 */

#include <common.h>
#include <asm/io.h>
#include <lcd.h>
#include <cygnus_pl111.h>

#define ASIU_TOP_PAD_CTRL_0_ADDR   0x180aa05c

/*
 * Tianma Display Panel TM050RDHG03
 * INNOLUX Display Panel HJ050NA-01K
 */
struct clcd_config lcd_config = {
	.address = (struct clcd_registers *)LCD_BASE_ADDRESS,
	.tim0 = 0x2F272FC4,
	.tim1 = 0x200D09DF,
	.tim2 = 0x031F3804,
	.tim3 = 0x00010003,
	.cntl = 0x00000926
};

/* Supports 24 bpp but driver will operate in 32 bpp mode */
vidinfo_t panel_info = {
	.vl_col  = 800,
	.vl_row  = 480,
	.vl_bpix = 3,	/* Bits per pixel, 2^5 = 32 */
	.cmap = (ushort *)LCD_BASE_ADDRESS + LCD_CMAP_OFFSET, /* color map */
	.priv = &lcd_config /* driver-specific data */
};

int clcd_panel_init(vidinfo_t *panel_info)
{
	return 0;
}

