#include <config.h>
#include <common.h>
#include <asm/io.h>

#if defined(CONFIG_CYGNUS)

#define CRMU_IOMUX_CTRL0 0x0301d0c8
#define CRMU_IOMUX_CTRL1 0x0301d0cc
#define CRMU_IOMUX_CTRL2 0x0301d0d0
#define CRMU_IOMUX_CTRL3 0x0301d0d4
#define CRMU_IOMUX_CTRL4 0x0301d0d8
#define CRMU_IOMUX_CTRL5 0x0301d0dc
#define CRMU_IOMUX_CTRL6 0x0301d0e0
#define CRMU_IOMUX_CTRL7 0x0301d0e4

#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO0_SEL_L 2
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO0_SEL_R 0
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO1_SEL_L 6
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO1_SEL_R 4
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO2_SEL_L 10
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO2_SEL_R 8
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO3_SEL_L 14
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO3_SEL_R 12
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO4_SEL_L 18
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO4_SEL_R 16
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO5_SEL_L 22
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO5_SEL_R 20
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO6_SEL_L 26
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO6_SEL_R 24
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO7_SEL_L 30
#define CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO7_SEL_R 28

#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO8_SEL_L 2
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO8_SEL_R 0
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO9_SEL_L 6
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO9_SEL_R 4
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO10_SEL_L 10
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO10_SEL_R 8
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO11_SEL_L 14
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO11_SEL_R 12
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO12_SEL_L 18
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO12_SEL_R 16
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO13_SEL_L 22
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO13_SEL_R 20
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO14_SEL_L 26
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO14_SEL_R 24
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO15_SEL_L 30
#define CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO15_SEL_R 28

#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO16_SEL_L 2
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO16_SEL_R 0
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO17_SEL_L 6
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO17_SEL_R 4
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO18_SEL_L 10
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO18_SEL_R 8
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO19_SEL_L 14
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO19_SEL_R 12
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO20_SEL_L 18
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO20_SEL_R 16
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO21_SEL_L 22
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO21_SEL_R 20
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO22_SEL_L 26
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO22_SEL_R 24
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO23_SEL_L 30
#define CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO23_SEL_R 28

#define CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM0_SEL_L 2
#define CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM0_SEL_R 0
#define CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM1_SEL_L 6
#define CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM1_SEL_R 4
#define CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM2_SEL_L 10
#define CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM2_SEL_R 8
#define CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM3_SEL_L 14
#define CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM3_SEL_R 12

#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI0_SEL_L 2
#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI0_SEL_R 0
#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI1_SEL_L 6
#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI1_SEL_R 4
#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI2_SEL_L 10
#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI2_SEL_R 8
#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI3_SEL_L 14
#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI3_SEL_R 12
#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_D1W_SEL_L 18
#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_D1W_SEL_R 16
#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_LCD_SEL_L 22
#define CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_LCD_SEL_R 20

#define CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_DTE_SEL_L 6
#define CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_DTE_SEL_R 4
#define CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART0_SEL_L 2
#define CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART0_SEL_R 0
#define CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_SEL_L 10
#define CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_SEL_R 8
#define CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART3_SEL_L 14
#define CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART3_SEL_R 12

#define CRMU_IOMUX_CTRL6__CORE_TO_IOMUX_SDIO1_CAN0_SPI4_SEL_L 10
#define CRMU_IOMUX_CTRL6__CORE_TO_IOMUX_SDIO1_CAN0_SPI4_SEL_R 8
#define CRMU_IOMUX_CTRL6__CORE_TO_IOMUX_SDIO1_CAN1_SPI4_SEL_L 14
#define CRMU_IOMUX_CTRL6__CORE_TO_IOMUX_SDIO1_CAN1_SPI4_SEL_R 12

#define CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_SRAM_RGMII_SEL_L 10
#define CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_SRAM_RGMII_SEL_R 8
#define CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_QSPI_GPIO_SEL_L 14
#define CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_QSPI_GPIO_SEL_R 12
#define CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_SRAM_RGMII_SEL_R 8
#define CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_SRAM_RGMII_SEL_WIDTH 3
#define CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_RGMII_SEL_L 6
#define CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_RGMII_SEL_R 4

#define CDRU_UART0_IO_CONTROL 0x0301d120
#define CDRU_UART1_IO_CONTROL 0x0301d11c
#define CDRU_UART2_IO_CONTROL 0x0301d118
#define CDRU_UART3_IO_CONTROL 0x0301d114
#define CDRU_UART4_IO_CONTROL 0x0301d110

#define CRMU_IOMUX_CONTROL 0x03024004
#define CRMU_CLOCK_GATE_CTRL 0x0301d054
#define CRMU_CHIP_IO_PAD_CONTROL 0x0301d0bc

#define CRMU_IOMUX_CONTROL__CRMU_OVERRIDE_UART_RX 0

void io_mux_set(u32 addr, u32 b, u32 e, u32 val)
{
	u32 i;
	u32 mask = 0;
	u32 reg_val = readl(addr);

	for (i = b; i <= e; i++)
		mask |= 1 << i;

	reg_val = (reg_val & (~mask)) | (val << b);

	writel(reg_val, addr);
}

void iproc_i2c_iomux(int op)
{
}

void iproc_gpio116_iomux(int op)
{
	if (op) {
		io_mux_set(CRMU_IOMUX_CTRL7, CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_QSPI_GPIO_SEL_R,
				CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_QSPI_GPIO_SEL_L, 3);
	} else {
		io_mux_set(CRMU_IOMUX_CTRL7, CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_QSPI_GPIO_SEL_R,
				CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_QSPI_GPIO_SEL_L, 0);
	}
}

void iproc_rgmii_iomux(int op)
{
	if (op) {
		io_mux_set(CRMU_IOMUX_CTRL7, CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_SRAM_RGMII_SEL_R,
				CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_SRAM_RGMII_SEL_L, 2);
		io_mux_set(CRMU_IOMUX_CTRL7, CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_RGMII_SEL_R,
				CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_RGMII_SEL_L, 2);
	} else {
		io_mux_set(CRMU_IOMUX_CTRL7, CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_SRAM_RGMII_SEL_R,
				CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_SRAM_RGMII_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL7, CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_RGMII_SEL_R,
				CRMU_IOMUX_CTRL7__CORE_TO_IOMUX_CAMERA_RGMII_SEL_L, 0);
	}
}

void iproc_sram_iomux(int op)
{
	if (op) {
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_LCD_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_LCD_SEL_L, 1);
	} else {
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_LCD_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_LCD_SEL_L, 0);
	}
}

void iproc_lcd_iomux(int op)
{
	io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_LCD_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_LCD_SEL_L, 0);
}

void iproc_keypad_iomux(int op)
{
	if (op) {
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO8_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO8_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO9_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO9_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO10_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO10_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO11_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO11_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO12_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO12_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO13_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO13_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO14_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO14_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO15_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO15_SEL_L, 1);

		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO16_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO16_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO17_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO17_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO18_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO18_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO19_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO19_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO20_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO21_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO21_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO21_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO22_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO22_SEL_L, 1);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO23_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO23_SEL_L, 1);

	} else {
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO8_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO8_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO9_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO9_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO10_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO10_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO11_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO11_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO12_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO12_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO13_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO13_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO14_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO14_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL1, CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO15_SEL_R,
				CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO15_SEL_L, 0);

		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO16_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO16_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO17_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO17_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO18_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO18_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO19_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO19_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO20_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO21_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO21_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO21_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO22_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO22_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL2, CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO23_SEL_R,
				CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO23_SEL_L, 0);
	}
}

void iproc_aon_gpio_iomux(int op)
{
	if (op) {
		io_mux_set(CRMU_IOMUX_CONTROL, CRMU_IOMUX_CONTROL__CRMU_OVERRIDE_UART_RX,
				CRMU_IOMUX_CONTROL__CRMU_OVERRIDE_UART_RX, 1);
	} else {
		io_mux_set(CRMU_IOMUX_CONTROL, CRMU_IOMUX_CONTROL__CRMU_OVERRIDE_UART_RX,
				CRMU_IOMUX_CONTROL__CRMU_OVERRIDE_UART_RX, 0);
	}
}

void iproc_gpio_iomux(int op)
{
	io_mux_set(CRMU_IOMUX_CTRL0,CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO0_SEL_R,
			CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO0_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL0,CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO1_SEL_R,
			CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO1_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL0,CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO2_SEL_R,
			CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO2_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL0,CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO3_SEL_R,
			CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO3_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL0,CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO4_SEL_R,
			CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO4_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL0,CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO5_SEL_R,
			CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO5_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL0,CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO6_SEL_R,
			CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO6_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL0,CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO7_SEL_R,
			CRMU_IOMUX_CTRL0__CORE_TO_IOMUX_GPIO7_SEL_L, 0);

	io_mux_set(CRMU_IOMUX_CTRL1,CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO8_SEL_R,
			CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO8_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL1,CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO9_SEL_R,
			CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO9_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL1,CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO10_SEL_R,
			CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO10_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL1,CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO11_SEL_R,
			CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO11_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL1,CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO12_SEL_R,
			CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO12_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL1,CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO13_SEL_R,
			CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO13_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL1,CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO14_SEL_R,
			CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO14_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL1,CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO15_SEL_R,
			CRMU_IOMUX_CTRL1__CORE_TO_IOMUX_GPIO15_SEL_L, 0);

	io_mux_set(CRMU_IOMUX_CTRL2,CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO16_SEL_R,
			CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO16_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL2,CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO17_SEL_R,
			CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO17_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL2,CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO18_SEL_R,
			CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO18_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL2,CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO19_SEL_R,
			CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO19_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL2,CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO20_SEL_R,
			CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO21_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL2,CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO21_SEL_R,
			CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO21_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL2,CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO22_SEL_R,
			CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO22_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL2,CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO23_SEL_R,
			CRMU_IOMUX_CTRL2__CORE_TO_IOMUX_GPIO23_SEL_L, 0);
}

void iproc_pwm_iomux(int op)
{
	io_mux_set(CRMU_IOMUX_CTRL3,CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM0_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM0_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL3,CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM1_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM1_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL3,CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM2_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM2_SEL_L, 0);
	io_mux_set(CRMU_IOMUX_CTRL3,CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM3_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM3_SEL_L, 0);
}

void iproc_spi_iomux(int spi, int op)
{
	io_mux_set(CRMU_CHIP_IO_PAD_CONTROL, 0, 1, 0);

	switch (spi) {
	case 0:
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI0_SEL_R,
				CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI0_SEL_L, 0);
		break;
	case 1:
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI1_SEL_R,
		CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI1_SEL_L, 0);
		break;
	case 2:
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI2_SEL_R,
		CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI2_SEL_L, 0);
		break;
	case 3:
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI3_SEL_R,
		CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI3_SEL_L, 0);
		break;
	case 4:
		io_mux_set(CRMU_IOMUX_CTRL6, CRMU_IOMUX_CTRL6__CORE_TO_IOMUX_SDIO1_CAN1_SPI4_SEL_R,
				CRMU_IOMUX_CTRL6__CORE_TO_IOMUX_SDIO1_CAN1_SPI4_SEL_L, 2);
		io_mux_set(CRMU_IOMUX_CTRL6, CRMU_IOMUX_CTRL6__CORE_TO_IOMUX_SDIO1_CAN0_SPI4_SEL_R,
				CRMU_IOMUX_CTRL6__CORE_TO_IOMUX_SDIO1_CAN0_SPI4_SEL_L, 2);
		break;
	case 5:
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_LCD_SEL_R,
		CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_LCD_SEL_L, 2);
		break;
	default:
		break;
	}
}

void iproc_d1w_iomux(int op)
{
	io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_D1W_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_D1W_SEL_L, 0);
}

void iproc_pcie_iomux(int op)
{
	if (op) {
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI3_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI3_SEL_L, 3);
	} else {
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI3_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI3_SEL_L, 0);
	}
}

void iproc_uart_iomux(int op)
{
	/*enable IOMUX*/
	writel(0, CRMU_CHIP_IO_PAD_CONTROL);
	/*disable clock gate ctrl*/

	writel(0x1, CRMU_CLOCK_GATE_CTRL);

	/*enable uart tx PAD (OEB)*/
	writel(0xc, CRMU_IOMUX_CONTROL);

	/*io driver strength*/
	writel(0x3, CDRU_UART0_IO_CONTROL);
	io_mux_set(CRMU_IOMUX_CTRL5, CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART0_SEL_R,
			CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART0_SEL_L, 0);

	writel(0x3, CDRU_UART1_IO_CONTROL);
	io_mux_set(CRMU_IOMUX_CTRL5, CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_SEL_R,
			CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_SEL_L, 0);

	writel(0x3, CDRU_UART3_IO_CONTROL);
	io_mux_set(CRMU_IOMUX_CTRL5, CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART3_SEL_R,
			CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART3_SEL_L, 0);
	if (op) {
		/*enable UART2 */
		writel(0x3, CDRU_UART2_IO_CONTROL);
		io_mux_set(CRMU_IOMUX_CTRL5, CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_DTE_SEL_R,
			CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_DTE_SEL_L, 1);
		/*enable UART4 */
		writel(0x3, CDRU_UART4_IO_CONTROL);
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_D1W_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_D1W_SEL_L, 1);
	} else {
		io_mux_set(CRMU_IOMUX_CTRL5, CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_DTE_SEL_R,
			CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_DTE_SEL_L, 0);

		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_D1W_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_D1W_SEL_L, 0);
	}
}

void iproc_nand_iomux(int op)
{
	if (op) {
		/* width */
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI1_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI1_SEL_L, 3);
		/* page size */
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI2_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI2_SEL_L, 3);
		io_mux_set(CRMU_IOMUX_CTRL5, CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_DTE_SEL_R,
			CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_DTE_SEL_L, 3);
		/* ecc */
		io_mux_set(CRMU_IOMUX_CTRL3, CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM0_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM0_SEL_L, 3);
		io_mux_set(CRMU_IOMUX_CTRL3, CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM1_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM1_SEL_L, 3);
		io_mux_set(CRMU_IOMUX_CTRL3, CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM2_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM2_SEL_L, 3);
		io_mux_set(CRMU_IOMUX_CTRL3, CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM3_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM3_SEL_L, 3);
	} else {
		/* width */
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI1_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI1_SEL_L, 0);
		/* page size */
		io_mux_set(CRMU_IOMUX_CTRL4, CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI2_SEL_R,
			CRMU_IOMUX_CTRL4__CORE_TO_IOMUX_SPI2_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL5, CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_DTE_SEL_R,
			CRMU_IOMUX_CTRL5__CORE_TO_IOMUX_UART1_DTE_SEL_L, 0);
		/* ecc */
		io_mux_set(CRMU_IOMUX_CTRL3, CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM0_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM0_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL3, CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM1_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM1_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL3, CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM2_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM2_SEL_L, 0);
		io_mux_set(CRMU_IOMUX_CTRL3, CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM3_SEL_R,
			CRMU_IOMUX_CTRL3__CORE_TO_IOMUX_PWM3_SEL_L, 0);
	 }
}

#endif
